#include <stdio.h>
#include <stdlib.h>
#include "auto_test.h"
#include "test_func.h"
#include "iniparser.h"


int g_iIniChannel = 0;
int g_iIniStream = 0;
dictionary *g_pIni = NULL;

void auto_test()
{
    fprintf(stderr, "Auto test now\n");

    g_pIni = iniparser_load("auto_test.ini");
    if(NULL == g_pIni)
    {
        fprintf(stderr, "Load ini file failed\n");
	return;
    }

    g_iIniChannel = iniparser_getint(g_pIni, "Channel:channel", -1);
    g_iIniStream = iniparser_getint(g_pIni, "StreamNum:stream", -1);

    Auto_SetGetVideoPara();
    Auto_SetGetVideoparaSchedule();
    Auto_SetGetVideoQuality();
    Auto_SetGetFrameRate();
    Auto_SetGetStreamType();
    Auto_SetGetThreshold();
    Auto_SetGetMotionDetection();
    Auto_SetGetMotionDetetionArea();
    Auto_SetGetMotionDecLinkRec();
    Auto_SetGetMotionDecLinkSnap();
    Auto_SetGetMotionDecLinkOutport();
    Auto_SetGetMotionDetectSchedule();
    Auto_SetGetOsdText();
    Auto_SetGetOsdType();
    Auto_SetGetDateFormat();
    Auto_SetGetAudioChannel();
    Auto_SetGetAlarmOutput();
    Auto_SetGetAlarmPortEnable();
    Auto_SetGetAlarmOutMode();

    Auto_SetGetInportAlarmLinkRec();
    Auto_SetGetInportAlarmLinkSnap();
    Auto_SetGetInportAlmLinkOutport();
    Auto_SetGetInportAlarmLinkSoundDisplay();
    Auto_SetGetInportAlarmLinkPTZ();

    Auto_SetGetInportAlarmSchedule();
    Auto_SetGetOutportAlarmSchedule();
    Auto_SetGetOutportAlarmDelay();
    Auto_SetGetInportEnable();
    Auto_SetGetOutportEnable();
    Auto_SetGetOutportState();
    Auto_SetGetAlmVdoCovThreshold();
    Auto_SetGetAlmVideoCov();
    Auto_SetGetDeviceType();
    Auto_SetGetComFormat();
    Auto_SetGetAlarmVideoLost();
    Auto_SetGetVideoLostLinkPTZ();
    Auto_SetGetVideoLostLinkSoundDisplay();
    Auto_SetGetVideoLostLinkOutport();
    Auto_SetGetVideoLostSchedule();
    Auto_SetGetVideoLostLinkRec();
    Auto_SetGetVideoLostLinkSnap();
    Auto_SetGetIFrameRate();
    Auto_SetGetHTTPPort();
    Auto_SetGetMaxConUser();
    Auto_SetGetDHCPParam();
    Auto_SetGetWifiDHCPParam();
    Auto_SetGetVideoCovArea();
    Auto_SetGetVideoSize();
    Auto_SetGetMaxKByteRate();
    Auto_SetGetDomainParsePara();
    Auto_SetGetReducenoiseState();
    Auto_SetGetBothStreamSame();
    Auto_SetGetPPPoEInfo();
    Auto_SetGetEncodeMode();
    Auto_SetGetPreferMode();
    Auto_SetGetVideoNPMode();
    Auto_SetGetAudioEncoder();
    Auto_SetGetMediaStreamClient();
    Auto_SetGetEmailAlarm();
    Auto_SetGetEmailAlarmEnable();
    Auto_SetGetScene();
    Auto_SetGetSensorFlip();
    Auto_SetGetSensorMirror();
    Auto_SetGetWifiParam();
    Auto_SetGetPrivacyProtect();
    Auto_SetGetUPNPEnable();
    Auto_SetGetDDNSPara();
    Auto_SetGetFuncListArray();
    Auto_SetGetVencType();
    Auto_SetGetComServer();
    Auto_SetGet3GDialog();
    Auto_SetGet3GMessage();
    Auto_SetGet3GTaskSchedule();
    Auto_SetGet3GNotify();
    Auto_SetGetHDCamer();
    Auto_SetGetAlarmServer();

    Auto_WriteReadUserData();
    Auto_DrawGetTextOnVideo();
    Auto_ShowGetBitrateOnVideo();
    Auto_LogFileSetGetProperty();
    Auto_NetFileSetGetRecordRule();
    Auto_NetFileSetGetAlarmRule();
    Auto_NetFileSetGetAlarmState();
    Auto_NetFileSetGetTaskState();
    Auto_NetFileSetGetTaskSchedule();
    Auto_NetFileSetGetMapStoreDevice();
    Auto_NetFileSetGetExtendname();

    Auto_SetGetEmailAlarmEx();
    Auto_SetGetFTPUploadConfig();
    Auto_SetGetDigitalChannelConfig();
    Auto_DigitalChannelSend();
    Auto_SetGetVideoNPModeEx();
    Auto_GetDigitalChannelNum();
    Auto_GetChannelProperty();
    Auto_SetGetHDCamerEx();
    /**********************ӿڱ׼豸֧***********************/
//  Auto_SetGetDeviceTimerReboot();
//  Auto_SetGetVideoCoverSchedule();
//  Auto_SetGetCPUMEMAlarmThreshold();
//  Auto_SetGetDZInfo();
//  Auto_SetGetPTZAutoBack();
//  Auto_SetGet3GVPND();
    /********************************end********************************/

    Auto_SetGetPort();
    Auto_GetMaxVideoSize();
    Auto_SetGetBitRatePercent();
    Auto_SetGetFTPUsage();
    Auto_GetVideoParam();
    Auto_SetGetOSDAlpha();
    Auto_DeviceSetup();
    Auto_SetGetChannelSipConfig();
    Auto_SetGet3GConfig();
    Auto_SetGetVideoCombine();
    Auto_SetGetCDBurnConfig();
    Auto_SetGetPreRecEnable();
    Auto_VCASetGetConfig();

    Auto_SetGetColorToGray();
    Auto_GetExceptionMsg();
    Auto_SetGetCHNPTZFormat();
    Auto_GetProtocolList();
    Auto_SetGetCHNPTZCRUISE();
    Auto_SetGetFTPUpdate();

    Auto_SetGetOSDTypeColor();

	Auto_NetFileSetGetChannelParam();

    iniparser_freedict(g_pIni);

    fprintf(stderr, "Please type interface to test:");
}

void Auto_SetGetVideoPara()
{
    // SetVideoPara
    int iIniBright = iniparser_getint(g_pIni, "SetVideoPara:bright", -1);
    int iIniContrast = iniparser_getint(g_pIni, "SetVideoPara:contrast", -1);
    int iIniHue = iniparser_getint(g_pIni, "SetVideoPara:hue", -1);
    int iIniSaturation = iniparser_getint(g_pIni, "SetVideoPara:saturation", -1);

    STR_VideoParam sp;
    memset(&sp, 0, sizeof(sp));
    sp.m_u16Brightness = iIniBright;
    sp.m_u16Contrast = iIniContrast;
    sp.m_u16Hue = iIniHue;
    sp.m_u16Saturation = iIniSaturation;

    NetClient_SetVideoPara(g_iLogonID, g_iIniChannel, &sp);

    fprintf(stderr, "SetVideoPara  Wait .................. \n");
    usleep(1000*1000);

    // GetVideoPara
    memset(&sp, 0, sizeof(sp));
    NetClient_GetVideoPara(g_iLogonID, g_iIniChannel, &sp);

    if(iIniBright == sp.m_u16Brightness &&
       iIniContrast == sp.m_u16Contrast &&
       iIniHue == sp.m_u16Hue &&
       iIniSaturation == sp.m_u16Saturation)
    {
	fprintf(stderr, "SetVideoPara GetVideoPara .................. [OK]\n");
    }
    else
    {
	fprintf(stderr, "SetVideoPara GetVideoPara .................. [FAIL]\n");
    }
}

void Auto_SetGetVideoparaSchedule()
{
    // SetVideoparaSchedule
    int iIniBright = iniparser_getint(g_pIni, "SetVideoparaSchedule:bright", -1);
    int iIniContrast = iniparser_getint(g_pIni, "SetVideoparaSchedule:contrast", -1);
    int iIniHue = iniparser_getint(g_pIni, "SetVideoparaSchedule:hue", -1);
    int iIniSaturation = iniparser_getint(g_pIni, "SetVideoparaSchedule:saturation", -1);

    int iIniStartHour = iniparser_getint(g_pIni, "SetVideoparaSchedule:start_hour", -1);
    int iIniStartMin = iniparser_getint(g_pIni, "SetVideoparaSchedule:start_min", -1);
    int iIniStopHour = iniparser_getint(g_pIni, "SetVideoparaSchedule:stop_hour", -1);
    int iIniStopMin = iniparser_getint(g_pIni, "SetVideoparaSchedule:stop_min", -1);

    STR_VideoParam sp[MAX_TIMESEGMENT];
    for(int i=0; i<MAX_TIMESEGMENT; i++)
    {
        memset(&sp[i], 0, sizeof(STR_VideoParam));
    }

    sp[0].m_u16Brightness = iIniBright;
    sp[0].m_u16Contrast = iIniContrast;
    sp[0].m_u16Hue = iIniHue;
    sp[0].m_u16Saturation = iIniSaturation;
    sp[0].strctTempletTime.iStartHour = iIniStartHour;
    sp[0].strctTempletTime.iStartMin = iIniStartMin;
    sp[0].strctTempletTime.iStopHour = iIniStopHour;
    sp[0].strctTempletTime.iStopMin = iIniStopMin;


    STR_VideoParam *pSP[] = {&sp[0], &sp[1], &sp[2], &sp[3]};


    NetClient_SetVideoparaSchedule(g_iLogonID, g_iIniChannel, pSP);

    fprintf(stderr, "SetVideoparaSchedule  Wait .................. \n");
    usleep(1000*1000);

    // GetVideoparaSchedule
    for(int i=0; i<MAX_TIMESEGMENT; i++)
    {
        memset(&sp[i], 0, sizeof(STR_VideoParam));
    }

    NetClient_GetVideoparaSchedule(g_iLogonID, g_iIniChannel, pSP);

    if( sp[0].m_u16Brightness == iIniBright &&
        sp[0].m_u16Contrast == iIniContrast &&
        sp[0].m_u16Hue == iIniHue &&
        sp[0].m_u16Saturation == iIniSaturation &&
        sp[0].strctTempletTime.iStartHour == iIniStartHour &&
        sp[0].strctTempletTime.iStartMin == iIniStartMin &&
        sp[0].strctTempletTime.iStopHour == iIniStopHour &&
        sp[0].strctTempletTime.iStopMin == iIniStopMin)
    {
	fprintf(stderr, "SetVideoPara GetVideoparaSchedule .................. [OK]\n");
    }
    else
    {
	fprintf(stderr, "SetVideoPara GetVideoparaSchedule .................. [FAIL]\n");
    }
}

void Auto_SetGetVideoQuality()
{
    // SetVideoQuality
    int iIniVideoQuality = iniparser_getint(g_pIni, "SetVideoQuality:quality", -1);

    NetClient_SetVideoQuality(g_iLogonID, g_iIniChannel, iIniVideoQuality, g_iIniStream);

    fprintf(stderr, "SetVideoQuality  Wait .................. \n");
    usleep(1000*1000);

    // GetVideoQuality
    int iVideoQuality = 0;
    NetClient_GetVideoQuality(g_iLogonID, g_iIniChannel, &iVideoQuality, g_iIniStream);

    if(iVideoQuality == iIniVideoQuality)
    {
        fprintf(stderr, "SetVideoQuality GetVideoQuality .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoQuality GetVideoQuality .................. [FAIL]\n");
    }
}

void Auto_SetGetFrameRate()
{
    // SetFrameRate
    int iIniFrameRate =  iniparser_getint(g_pIni, "SetFrameRate:rate", -1);

    NetClient_SetFrameRate(g_iLogonID, g_iIniChannel, iIniFrameRate, g_iIniStream);

    fprintf(stderr, "SetFrameRate Wait .................. \n");
    usleep(1000*1000);

    // GetFrameRate
    int iFrameRate = 0;
    NetClient_GetFrameRate(g_iLogonID, g_iIniChannel, &iFrameRate, g_iIniStream);

    if(iFrameRate == iIniFrameRate)
    {
        fprintf(stderr, "SetFrameRate GetFrameRate .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetFrameRate GetFrameRate .................. [FAIL]\n");
    }
}

void Auto_SetGetStreamType()
{
    // SetStreamType
    int iIniStreamType = iniparser_getint(g_pIni, "SetStreamType:type", -1);

    NetClient_SetStreamType(g_iLogonID, g_iIniChannel, iIniStreamType, g_iIniStream);

    fprintf(stderr, "SetStreamType Wait .................. \n");
    usleep(1000*1000);

    // GetStreamType
    int iStreamType = 0;
    NetClient_GetStreamType(g_iLogonID, g_iIniChannel, &iStreamType, g_iIniStream);
    if(iStreamType == iIniStreamType)
    {
        fprintf(stderr, "SetStreamType GetStreamType .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetStreamType GetStreamType .................. [FAIL]\n");
    }
}

void Auto_SetGetThreshold()
{
    // SetThreshold
    int iIniThreshold = iniparser_getint(g_pIni, "SetThreshold:threshold", -1);

    NetClient_SetThreshold(g_iLogonID, g_iIniChannel, iIniThreshold);

    fprintf(stderr, "SetThreshold Wait .................. \n");
    usleep(1000*1000);

    // GetThreshold
    int iThreshold = 0;
    NetClient_GetThreshold(g_iLogonID, g_iIniChannel, &iThreshold);
    if(iThreshold == iIniThreshold)
    {
        fprintf(stderr, "SetThreshold GetThreshold .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetThreshold GetThreshold .................. [FAIL]\n");
    }
}

void Auto_SetGetMotionDetection()
{
    // SetMotionDetection
    int iIniValue = iniparser_getint(g_pIni, "SetMotionDetection:value", -1);

    NetClient_SetMotionDetection(g_iLogonID, g_iIniChannel, iIniValue);

    fprintf(stderr, "SetMotionDetection Wait .................. \n");
    usleep(1000*1000);

    // GetMotionDetection
    int iValue = 0;
    NetClient_GetMotionDetection(g_iLogonID, g_iIniChannel, &iValue);
    if(iValue == iIniValue)
    {
        fprintf(stderr, "SetMotionDetection GetMotionDetection .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetMotionDetection GetMotionDetection .................. [FAIL]\n");
    }
}

void Auto_SetGetMotionDetetionArea()
{
    // SetMotionDetetionArea
    int iIniX = iniparser_getint(g_pIni, "SetMotionDetetionArea:x", -1);
    int iIniY = iniparser_getint(g_pIni, "SetMotionDetetionArea:y", -1);
    int iIniEnable = iniparser_getint(g_pIni, "SetMotionDetetionArea:enable", -1);

    NetClient_SetMotionDetetionArea(g_iLogonID, g_iIniChannel, iIniX, iIniY, iIniEnable);
    NetClient_SetMotionAreaEnable(g_iLogonID, g_iIniChannel);

    fprintf(stderr, "SetMotionDetetionArea Wait .................. \n");
    usleep(1000*1000);

    // GetMotionDetetionArea
    int iEnable = 0;
    NetClient_GetMotionDetetionArea(g_iLogonID, g_iIniChannel, iIniX, iIniY, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetMotionDetetionArea GetMotionDetetionArea .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetMotionDetetionArea GetMotionDetetionArea .................. [FAIL]\n");
    }
}

void Auto_SetGetMotionDecLinkRec()
{
    // SetMotionDecLinkRec
    int iIniEnable = iniparser_getint(g_pIni, "SetMotionDecLinkRec:enable", -1);

    NetClient_SetMotionDecLinkRec(g_iLogonID, g_iIniChannel, iIniEnable);

    fprintf(stderr, "SetMotionDecLinkRec Wait .................. \n");
    usleep(1000*1000);

    // GetMotionDecLinkRec
    int iEnable = 0;
    NetClient_GetMotionDecLinkRec(g_iLogonID, g_iIniChannel, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetMotionDecLinkRec GetMotionDecLinkRec .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetMotionDecLinkRec GetMotionDecLinkRec .................. [FAIL]\n");
    }
}

void Auto_SetGetMotionDecLinkSnap()
{
    // SetMotionDecLinkSnap
    int iIniEnable = iniparser_getint(g_pIni, "SetMotionDecLinkSnap:enable", -1);

    NetClient_SetMotionDecLinkSnap(g_iLogonID, g_iIniChannel, iIniEnable);

    fprintf(stderr, "SetMotionDecLinkSnap Wait .................. \n");
    usleep(1000*1000);

    // GetMotionDecLinkSnap
    int iEnable = 0;
    NetClient_GetMotionDecLinkSnap(g_iLogonID, g_iIniChannel, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetMotionDecLinkSnap GetMotionDecLinkSnap .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetMotionDecLinkSnap GetMotionDecLinkSnap .................. [FAIL]\n");
    }
}

void Auto_SetGetMotionDecLinkOutport()
{
    // SetMotionDecLinkOutport
    int iIniEnable = iniparser_getint(g_pIni, "SetMotionDecLinkOutport:enable", -1);

    NetClient_SetMotionDecLinkOutport(g_iLogonID, g_iIniChannel, iIniEnable);

    fprintf(stderr, "SetMotionDecLinkOutport Wait .................. \n");
    usleep(1000*1000);

    // GetMotionDecLinkOutport
    int iEnable = 0;
    NetClient_GetMotionDecLinkOutport(g_iLogonID, g_iIniChannel, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetMotionDecLinkOutport GetMotionDecLinkOutport .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetMotionDecLinkOutport GetMotionDecLinkOutport .................. [FAIL]\n");
    }
}

void Auto_SetGetMotionDetectSchedule()
{
    // SetMotionDetectSchedule
    int iIniWeekday = iniparser_getint(g_pIni, "SetMotionDetectSchedule:weekday", 0);
    int iIniStartHour = iniparser_getint(g_pIni, "SetMotionDetectSchedule:start_hour", 0);
    int iIniStartMin = iniparser_getint(g_pIni, "SetMotionDetectSchedule:start_min", 0);
    int iIniStopHour = iniparser_getint(g_pIni, "SetMotionDetectSchedule:stop_hour", 0);
    int iIniStopMin = iniparser_getint(g_pIni, "SetMotionDetectSchedule:stop_min", 0);

    NVS_SCHEDTIME timeSeg1,timeSeg2,timeSeg3,timeSeg4;

    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    PNVS_SCHEDTIME schedule[] = {&timeSeg1,&timeSeg2,&timeSeg3,&timeSeg4};

    timeSeg1.iStartHour = iIniStartHour;
    timeSeg1.iStartMin = iIniStartMin;
    timeSeg1.iStopHour = iIniStopHour;
    timeSeg1.iStopMin = iIniStopMin;

    NetClient_SetMotionDetectSchedule(g_iLogonID, g_iIniChannel, iIniWeekday, schedule);

    fprintf(stderr, "SetMotionDetectSchedule Wait .................. \n");
    usleep(1000*1000);

    // GetMotionDetectSchedule
    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    NetClient_GetMotionDetectSchedule(g_iLogonID, g_iIniChannel, iIniWeekday, schedule);
    if( timeSeg1.iStartHour == iIniStartHour &&
        timeSeg1.iStartMin == iIniStartMin &&
        timeSeg1.iStopHour == iIniStopHour &&
        timeSeg1.iStopMin == iIniStopMin)
    {
        fprintf(stderr, "SetMotionDetectSchedule GetMotionDetectSchedule .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetMotionDetectSchedule GetMotionDetectSchedule .................. [FAIL]\n");
    }
}

void Auto_SetGetOsdText()
{
    // SetOsdText
    char *pcText = iniparser_getstring(g_pIni, "SetOsdText:text", NULL);
    unsigned long ulIniTextColor = iniparser_getint(g_pIni, "SetOsdText:color", 0);

    NetClient_SetOsdText(g_iLogonID, g_iIniChannel, (unsigned char*)pcText, ulIniTextColor);

    fprintf(stderr, "SetOsdText Wait .................. \n");
    usleep(1000*1000);

    // GetOsdText
    unsigned char ucText[2048] = {0};
    unsigned long ulTextColor = 0;
    NetClient_GetOsdText(g_iLogonID, g_iIniChannel, ucText, &ulTextColor);
    if(ulTextColor == ulIniTextColor &&
       0 == strcmp((char*)ucText, pcText))
    {
        fprintf(stderr, "SetOsdText GetOsdText .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetOsdText GetOsdText .................. [FAIL]\n");
    }
}

void Auto_SetGetOsdType()
{
    // SetOsdType
    int iIniXPos = iniparser_getint(g_pIni, "SetOsdType:xPos", -1);
    int iIniYPos = iniparser_getint(g_pIni, "SetOsdType:yPos", -1);
    int iIniType = iniparser_getint(g_pIni, "SetOsdType:type", -1);
    int iIniState = iniparser_getint(g_pIni, "SetOsdType:state", -1);

    NetClient_SetOsdType(g_iLogonID, g_iIniChannel, iIniXPos, iIniYPos, iIniType, iIniState);

    fprintf(stderr, "SetOsdType Wait .................. \n");
    usleep(1000*1000);

    // GetOsdType
    int iXpos = 0;
    int iYpos = 0;
    int iState = 0;

    NetClient_GetOsdType(g_iLogonID, g_iIniChannel, iIniType, &iXpos, &iYpos, &iState);
    if(iXpos == iIniXPos &&
       iYpos == iIniYPos &&
       iState == iIniState)
    {
        fprintf(stderr, "SetOsdType GetOsdType .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetOsdType GetOsdType .................. [FAIL]\n");
    }
}

void Auto_SetGetDateFormat()
{
    // SetDateFormat
    int iIniFormat = iniparser_getint(g_pIni, "SetDateFormat:format", -1);
    int iIniSeparator = iniparser_getint(g_pIni, "SetDateFormat:separator", -1);


    NetClient_SetDateFormat(g_iLogonID, iIniFormat, (char)iIniSeparator);

    fprintf(stderr, "SetDateFormat Wait .................. \n");
    usleep(1000*1000);

    // GetDateFormat
    int iFormat = 0;
    char cSeparator;

    NetClient_GetDateFormat(g_iLogonID, &iFormat, &cSeparator);
    if(iFormat == iIniFormat &&
       cSeparator == iIniSeparator)
    {
        fprintf(stderr, "SetDateFormat GetDateFormat .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetDateFormat GetDateFormat .................. [FAIL]\n");
    }
}

void Auto_SetGetAudioChannel()
{
    // SetAudioChannel
    int iIniAudio = iniparser_getint(g_pIni, "SetAudioChannel:channel", -1);

    NetClient_SetAudioChannel(g_iLogonID, g_iIniChannel, iIniAudio);

    fprintf(stderr, "SetAudioChannel Wait .................. \n");
    usleep(1000*1000);

    // GetAudioChannel
    int iAudio = 0;

    NetClient_GetAudioChannel(g_iLogonID, g_iIniChannel, &iAudio);
    if(iAudio == iIniAudio)
    {
        fprintf(stderr, "SetAudioChannel GetAudioChannel .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetAudioChannel GetAudioChannel .................. [FAIL]\n");
    }
}

void Auto_SetGetAlarmOutput()
{
    // SetAlarmOutput
    int iIniInport = iniparser_getint(g_pIni, "SetAlarmOutput:inport", -1);
    int iIniOutport = iniparser_getint(g_pIni, "SetAlarmOutput:outport", -1);

    NetClient_SetAlarmOutput(g_iLogonID, iIniInport, iIniOutport);

    fprintf(stderr, "SetAlarmOutput Wait .................. \n");
    usleep(1000*1000);

    // GetAlarmOutput
    unsigned long ulAlarmoutport = 0;

    NetClient_GetAlarmOutput(g_iLogonID, iIniInport, &ulAlarmoutport);
    if((int)ulAlarmoutport == iIniOutport)
    {
        fprintf(stderr, "SetAlarmOutput GetAlarmOutput .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetAlarmOutput GetAlarmOutput .................. [FAIL]\n");
    }
}

void Auto_SetGetAlarmPortEnable()
{
    // SetAlarmPortEnable
    int iIniInport = iniparser_getint(g_pIni, "SetAlarmPortEnable:inport", -1);
    int iIniEnable = iniparser_getint(g_pIni, "SetAlarmPortEnable:enable", -1);

    NetClient_SetAlarmPortEnable(g_iLogonID, iIniInport, iIniEnable);

    fprintf(stderr, "SetAlarmPortEnable Wait .................. \n");
    usleep(1000*1000);

    // GetAlarmPortEnable
    int iEnable = 0;

    NetClient_GetAlarmPortEnable(g_iLogonID, iIniInport, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetAlarmPortEnable GetAlarmPortEnable .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetAlarmPortEnable GetAlarmPortEnable .................. [FAIL]\n");
    }
}

//-----------------------------------------------------------------------------------------------

void Auto_SetGetInportAlarmLinkRec()
{
    // SetInportAlarmLinkRec
    int iIniInport = iniparser_getint(g_pIni, "SetInportAlarmLinkRec:inport", -1);
    int iIniEnable = iniparser_getint(g_pIni, "SetInportAlarmLinkRec:enable", -1);

    NetClient_SetInportAlarmLinkRec(g_iLogonID, iIniInport, iIniEnable);

    fprintf(stderr, "SetInportAlarmLinkRec Wait .................. \n");
    usleep(1000*1000);

    // GetInportAlarmLinkRec
    int iEnable = 0;

    NetClient_GetInportAlarmLinkRec(g_iLogonID, iIniInport, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetAlarmPortEnable GetInportAlarmLinkRec .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetAlarmPortEnable GetInportAlarmLinkRec .................. [FAIL]\n");
    }
}

void Auto_SetGetInportAlarmLinkSnap()
{
    // SetInportAlarmLinkSnap
    int iIniInport = iniparser_getint(g_pIni, "SetInportAlarmLinkSnap:inport", -1);
    int iIniEnable = iniparser_getint(g_pIni, "SetInportAlarmLinkSnap:enable", -1);

    NetClient_SetInportAlarmLinkSnap(g_iLogonID, iIniInport, iIniEnable);

    fprintf(stderr, "SetInportAlarmLinkSnap Wait .................. \n");
    usleep(1000*1000);

    // GetInportAlarmLinkSnap
    int iEnable = 0;

    NetClient_GetInportAlarmLinkSnap(g_iLogonID, iIniInport, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetInportAlarmLinkSnap GetInportAlarmLinkSnap .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetInportAlarmLinkSnap GetInportAlarmLinkSnap .................. [FAIL]\n");
    }
}

//=========================================================================================================

void Auto_SetGetInportAlarmLinkPTZ()
{
    // SetInportAlarmLinkPTZ
    int iIniInport = iniparser_getint(g_pIni, "SetInportAlarmLinkPTZ:inport", -1);
    int iIniLinkChannel = iniparser_getint(g_pIni, "SetInportAlarmLinkPTZ:link_channel", -1);
    int iIniLinkType = iniparser_getint(g_pIni, "SetInportAlarmLinkPTZ:link_type", -1);
    int iIniActNum = iniparser_getint(g_pIni, "SetInportAlarmLinkPTZ:act_num", -1);


    NetClient_SetInportAlarmLinkPTZ(g_iLogonID, iIniInport, iIniLinkChannel, iIniLinkType, iIniActNum);

    fprintf(stderr, "SetInportAlarmLinkPTZ Wait .................. \n");
    usleep(1000*1000);

    // GetInportAlarmLinkPTZ
    int iLinkType = 0;
    int iActNum = 0;

    NetClient_GetInportAlarmLinkPTZ(g_iLogonID, iIniInport, iIniLinkChannel, &iLinkType, &iActNum);
    if(iLinkType == iIniLinkType &&
       iActNum == iIniActNum)
    {
        fprintf(stderr, "SetInportAlarmLinkPTZ GetInportAlarmLinkPTZ .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetInportAlarmLinkPTZ GetInportAlarmLinkPTZ .................. [FAIL]\n");
    }
}

void Auto_SetGetInportAlarmLinkSoundDisplay()
{
    // SetInportAlarmLinkSoundDisplay
    int iIniInport = iniparser_getint(g_pIni, "SetInportAlarmLinkSoundDisplay:inport", -1);
    int iIniSoundEnable = iniparser_getint(g_pIni, "SetInportAlarmLinkSoundDisplay:sound_enable", -1);
    int iIniDisplayEnable = iniparser_getint(g_pIni, "SetInportAlarmLinkSoundDisplay:display_enable", -1);


    NetClient_SetInportAlarmLinkSoundDisplay(g_iLogonID, iIniInport, iIniSoundEnable, iIniDisplayEnable);

    fprintf(stderr, "SetInportAlarmLinkSoundDisplay Wait .................. \n");
    usleep(1000*1000);

    // GetInportAlarmLinkSoundDisplay
    int iSoundEnable = 0;
    int iDisplayEnable = 0;

    NetClient_GetInportAlarmLinkSoundDisplay(g_iLogonID, iIniInport, &iSoundEnable, &iDisplayEnable);
    if(iSoundEnable == iIniSoundEnable &&
       iDisplayEnable == iIniDisplayEnable)
    {
        fprintf(stderr, "SetInportAlarmLinkSoundDisplay GetInportAlarmLinkSoundDisplay .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetInportAlarmLinkSoundDisplay GetInportAlarmLinkSoundDisplay .................. [FAIL]\n");
    }
}

void Auto_SetGetInportAlmLinkOutport()
{
    // SetInportAlmLinkOutport
    int iIniInport = iniparser_getint(g_pIni, "SetInportAlmLinkOutport:inport", -1);
    int iIniEnable = iniparser_getint(g_pIni, "SetInportAlmLinkOutport:enable", -1);

    NetClient_SetInportAlmLinkOutport(g_iLogonID, iIniInport, iIniEnable);

    fprintf(stderr, "SetInportAlmLinkOutport Wait .................. \n");
    usleep(1000*1000);

    // GetInportAlmLinkOutport
    int iEnable = 0;

    NetClient_GetInportAlmLinkOutport(g_iLogonID, iIniInport, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetInportAlmLinkOutport GetInportAlmLinkOutport .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetInportAlmLinkOutport GetInportAlmLinkOutport .................. [FAIL]\n");
    }
}

void Auto_SetGetAlarmInMode()
{
    // SetAlarmInMode
    int iIniInport = iniparser_getint(g_pIni, "SetAlarmInMode:inport", -1);
    int iIniMode = iniparser_getint(g_pIni, "SetAlarmInMode:mode", -1);

    NetClient_SetAlarmInMode(g_iLogonID, iIniInport, iIniMode);

    fprintf(stderr, "SetAlarmInMode Wait .................. \n");
    usleep(1000*1000);

    // GetAlarmInMode
    int iMode = 0;

    NetClient_GetAlarmInMode(g_iLogonID, iIniInport, &iMode);
    if(iMode == iIniMode)
    {
        fprintf(stderr, "SetAlarmInMode GetAlarmInMode .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetAlarmInMode GetAlarmInMode .................. [FAIL]\n");
    }
}

void Auto_SetGetAlarmOutMode()
{
    // SetAlarmOutMode
    int iIniOutport = iniparser_getint(g_pIni, "SetAlarmOutMode:outport", -1);
    int iIniMode = iniparser_getint(g_pIni, "SetAlarmOutMode:mode", -1);
    int iIniPulseWidth = iniparser_getint(g_pIni, "SetAlarmOutMode:pulse_width", -1);


    NetClient_SetAlarmOutMode(g_iLogonID, iIniOutport, iIniMode, iIniPulseWidth);

    fprintf(stderr, "SetAlarmOutMode Wait .................. \n");
    usleep(1000*1000);

    // GetAlarmOutMode
    int iMode = 0;
    int iPulseWidth = 0;

    NetClient_GetAlarmOutMode(g_iLogonID, iIniOutport, &iMode, &iPulseWidth);
    if(iMode == iIniMode &&
       iPulseWidth == iIniPulseWidth)
    {
        fprintf(stderr, "SetAlarmOutMode GetAlarmOutMode .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetAlarmOutMode GetAlarmOutMode .................. [FAIL]\n");
    }
}

void Auto_SetGetInportAlarmSchedule()
{

    // SetInportAlarmSchedule
    int iIniInport = iniparser_getint(g_pIni, "SetInportAlarmSchedule:inport", 0);
    int iIniWeekday = iniparser_getint(g_pIni, "SetInportAlarmSchedule:weekday", 0);
    int iIniStartHour = iniparser_getint(g_pIni, "SetInportAlarmSchedule:start_hour", 0);
    int iIniStartMin = iniparser_getint(g_pIni, "SetInportAlarmSchedule:start_min", 0);
    int iIniStopHour = iniparser_getint(g_pIni, "SetInportAlarmSchedule:stop_hour", 0);
    int iIniStopMin = iniparser_getint(g_pIni, "SetInportAlarmSchedule:stop_min", 0);

    NVS_SCHEDTIME timeSeg1,timeSeg2,timeSeg3,timeSeg4;

    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    PNVS_SCHEDTIME schedule[] = {&timeSeg1,&timeSeg2,&timeSeg3,&timeSeg4};

    timeSeg1.iStartHour = iIniStartHour;
    timeSeg1.iStartMin = iIniStartMin;
    timeSeg1.iStopHour = iIniStopHour;
    timeSeg1.iStopMin = iIniStopMin;

    NetClient_SetInportAlarmSchedule(g_iLogonID, iIniInport, iIniWeekday, schedule);

    fprintf(stderr, "SetInportAlarmSchedule Wait .................. \n");
    usleep(1000*1000);

    // GetInportAlarmSchedule
    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    NetClient_GetInportAlarmSchedule(g_iLogonID, iIniInport, iIniWeekday, schedule);
    if(timeSeg1.iStartHour == iIniStartHour &&
       timeSeg1.iStartMin == iIniStartMin &&
       timeSeg1.iStopHour == iIniStopHour &&
       timeSeg1.iStopMin == iIniStopMin)
    {
        fprintf(stderr, "SetInportAlarmSchedule GetInportAlarmSchedule .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetInportAlarmSchedule GetInportAlarmSchedule .................. [FAIL]\n");
    }
}

void Auto_SetGetOutportAlarmSchedule()
{
    // SetOutportAlarmSchedule
    int iIniOutport = iniparser_getint(g_pIni, "SetOutportAlarmSchedule:outport", 0);
    int iIniWeekday = iniparser_getint(g_pIni, "SetOutportAlarmSchedule:weekday", 0);
    int iIniStartHour = iniparser_getint(g_pIni, "SetOutportAlarmSchedule:start_hour", 0);
    int iIniStartMin = iniparser_getint(g_pIni, "SetOutportAlarmSchedule:start_min", 0);
    int iIniStopHour = iniparser_getint(g_pIni, "SetOutportAlarmSchedule:stop_hour", 0);
    int iIniStopMin = iniparser_getint(g_pIni, "SetOutportAlarmSchedule:stop_min", 0);

    NVS_SCHEDTIME timeSeg1,timeSeg2,timeSeg3,timeSeg4;

    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    PNVS_SCHEDTIME schedule[] = {&timeSeg1,&timeSeg2,&timeSeg3,&timeSeg4};

    timeSeg1.iStartHour = iIniStartHour;
    timeSeg1.iStartMin = iIniStartMin;
    timeSeg1.iStopHour = iIniStopHour;
    timeSeg1.iStopMin = iIniStopMin;

    NetClient_SetOutportAlarmSchedule(g_iLogonID, iIniOutport, iIniWeekday, schedule);

    fprintf(stderr, "SetOutportAlarmSchedule Wait .................. \n");
    usleep(1000*1000);

    // GetOutportAlarmSchedule
    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    NetClient_GetOutportAlarmSchedule(g_iLogonID, iIniOutport, iIniWeekday, schedule);
    if(timeSeg1.iStartHour == iIniStartHour &&
       timeSeg1.iStartMin == iIniStartMin &&
       timeSeg1.iStopHour == iIniStopHour &&
       timeSeg1.iStopMin == iIniStopMin)
    {
        fprintf(stderr, "SetOutportAlarmSchedule GetOutportAlarmSchedule .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetOutportAlarmSchedule GetOutportAlarmSchedule .................. [FAIL]\n");
    }
}

void Auto_SetGetOutportAlarmDelay()
{
    // SetOutportAlarmDelay
    int iIniOutport = iniparser_getint(g_pIni, "SetOutportAlarmDelay:outport", -1);
    int iIniClearType = iniparser_getint(g_pIni, "SetOutportAlarmDelay:clear_type", -1);
    int iIniDelayTime = iniparser_getint(g_pIni, "SetOutportAlarmDelay:delay_time", -1);

    NetClient_SetOutportAlarmDelay(g_iLogonID, iIniOutport, iIniClearType, iIniDelayTime);

    fprintf(stderr, "SetOutportAlarmDelay Wait .................. \n");
    usleep(1000*1000);

    // GetOutportAlarmDelay
    int iClearType = 0;
    int iDelayTime = 0;

    NetClient_GetOutportAlarmDelay(g_iLogonID, iIniOutport, &iClearType, &iDelayTime);
    if(iClearType == iIniClearType &&
       iDelayTime == iDelayTime)
    {
        fprintf(stderr, "SetOutportAlarmDelay GetOutportAlarmDelay .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetOutportAlarmDelay GetOutportAlarmDelay .................. [FAIL]\n");
    }
}

void Auto_SetGetInportEnable()
{
    // SetInportEnable
    int iIniInport = iniparser_getint(g_pIni, "SetInportEnable:inport", -1);
    int iIniEnable = iniparser_getint(g_pIni, "SetInportEnable:enable", -1);

    NetClient_SetInportEnable(g_iLogonID, iIniInport, iIniEnable);

    fprintf(stderr, "SetInportEnable Wait .................. \n");
    usleep(1000*1000);

    // GetInportEnable
    int iEnable = 0;

    NetClient_GetInportEnable(g_iLogonID, iIniInport, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetInportEnable GetInportEnable .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetInportEnable GetInportEnable .................. [FAIL]\n");
    }
}

void Auto_SetGetOutportEnable()
{
    // SetOutportEnable
    int iIniOutport = iniparser_getint(g_pIni, "SetOutportEnable:outport", -1);
    int iIniEnable = iniparser_getint(g_pIni, "SetOutportEnable:enable", -1);

    NetClient_SetOutportEnable(g_iLogonID, iIniOutport, iIniEnable);

    fprintf(stderr, "SetOutportEnable Wait .................. \n");
    usleep(1000*1000);

    // GetOutportEnable
    int iEnable = 0;

    NetClient_GetOutportEnable(g_iLogonID, iIniOutport, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetOutportEnable GetOutportEnable .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetOutportEnable GetOutportEnable .................. [FAIL]\n");
    }
}

void Auto_SetGetOutportState()
{
    // SetOutportState
    int iIniOutport = iniparser_getint(g_pIni, "SetOutportState:outport", -1);
    int iIniState = iniparser_getint(g_pIni, "SetOutportState:state", -1);

    NetClient_SetOutportState(g_iLogonID, iIniOutport, iIniState);

    fprintf(stderr, "SetOutportState Wait .................. \n");
    usleep(1000*1000);

    // GetOutportState
    int iState = 0;

    NetClient_GetOutportState(g_iLogonID, iIniOutport, &iState);
    if(iState == iIniState)
    {
        fprintf(stderr, "SetOutportState GetOutportState .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetOutportState GetOutportState .................. [FAIL]\n");
    }
}

void Auto_SetGetAlmVdoCovThreshold()
{
    // SetAlmVdoCovThreshold
    int iIniThreshold = iniparser_getint(g_pIni, "SetAlmVdoCovThreshold:threshold", -1);

    NetClient_SetAlmVdoCovThreshold(g_iLogonID, g_iIniChannel, iIniThreshold);

    fprintf(stderr, "SetAlmVdoCovThreshold Wait .................. \n");
    usleep(1000*1000);

    // GetAlmVdoCovThreshold
    int iThreshold = 0;

    NetClient_GetAlmVdoCovThreshold(g_iLogonID, g_iIniChannel, &iThreshold);
    if(iThreshold == iIniThreshold)
    {
        fprintf(stderr, "SetAlmVdoCovThreshold GetAlmVdoCovThreshold .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetAlmVdoCovThreshold GetAlmVdoCovThreshold .................. [FAIL]\n");
    }
}

void Auto_SetGetAlmVideoCov()
{
    // SetAlmVideoCov
    int iIniEnable = iniparser_getint(g_pIni, "SetAlmVideoCov:enable", -1);

    NetClient_SetAlmVideoCov(g_iLogonID, g_iIniChannel, iIniEnable);

    fprintf(stderr, "SetAlmVideoCov Wait .................. \n");
    usleep(1000*1000);

    // GetAlmVideoCov
    int iEnable = 0;

    NetClient_GetAlmVideoCov(g_iLogonID, g_iIniChannel, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetAlmVideoCov GetAlmVideoCov .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetAlmVideoCov GetAlmVideoCov .................. [FAIL]\n");
    }
}

void Auto_SetGetDeviceType()
{
    // SetDeviceType
    int iIniComPort = iniparser_getint(g_pIni, "SetDeviceType:com_port", -1);
    int iIniDevAddress = iniparser_getint(g_pIni, "SetDeviceType:dev_address", -1);
    char *pcIniProtocol = iniparser_getstring(g_pIni, "SetDeviceType:protocol", NULL);

    NetClient_SetDeviceType(g_iLogonID, g_iIniChannel, iIniComPort, iIniDevAddress, pcIniProtocol);

    fprintf(stderr, "SetDeviceType Wait .................. \n");
    usleep(1000*1000);

    // GetDeviceType
    int iComPort = 0;
    int iDevAddress = 0;
    char cProtocol[256] = {0};

    NetClient_GetDeviceType(g_iLogonID, g_iIniChannel, &iComPort, &iDevAddress, cProtocol);
    if(iComPort == iIniComPort &&
       iDevAddress == iIniDevAddress &&
       0 == strcmp(pcIniProtocol, cProtocol))
    {
        fprintf(stderr, "SetDeviceType GetDeviceType .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetDeviceType GetDeviceType .................. [FAIL]\n");
    }
}
//-----------------------------------------------------------------------------------------
void Auto_SetGetComFormat()
{
    // SetComFormat
    int iIniComPort = iniparser_getint(g_pIni, "SetComFormat:com_port", -1);
    char *pcIniProtocol = iniparser_getstring(g_pIni, "SetComFormat:protocol", NULL);
    char *pcIniComFormat = iniparser_getstring(g_pIni, "SetComFormat:com_format", NULL);
    int iIniWorkMode = iniparser_getint(g_pIni, "SetComFormat:work_mode", -1);


    NetClient_SetComFormat(g_iLogonID, iIniComPort, pcIniProtocol, pcIniComFormat, iIniWorkMode);

    fprintf(stderr, "SetComFormat Wait .................. \n");
    usleep(1000*1000);

    // GetComFormat
    char cComFormat[256] = {0};
    int iWorkMode = 0;

    NetClient_GetComFormat(g_iLogonID, iIniComPort, cComFormat, &iWorkMode);
    if(iWorkMode == iIniWorkMode &&
       0 == strcmp(cComFormat, pcIniComFormat))
    {
        fprintf(stderr, "SetComFormat GetComFormat .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetComFormat GetComFormat .................. [FAIL]\n");
    }
}

void Auto_SetGetAlarmVideoLost()
{
    // SetAlarmVideoLost
    int iIniEnable = iniparser_getint(g_pIni, "SetAlarmVideoLost:enable", -1);

    NetClient_SetAlarmVideoLost(g_iLogonID, g_iIniChannel, iIniEnable);

    fprintf(stderr, "SetAlarmVideoLost Wait .................. \n");
    usleep(1000*1000);

    // GetAlarmVideoLost
    int iEnable = 0;

    NetClient_GetAlarmVideoLost(g_iLogonID, g_iIniChannel, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetAlarmVideoLost GetAlarmVideoLost .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetAlarmVideoLost GetAlarmVideoLost .................. [FAIL]\n");
    }
}

void Auto_SetGetVideoLostLinkPTZ()
{
    // SetVideoLostLinkPTZ
    int iIniLinkChannel = iniparser_getint(g_pIni, "SetVideoLostLinkPTZ:link_channel", -1);
    int iIniLinkType = iniparser_getint(g_pIni, "SetVideoLostLinkPTZ:linktype", -1);
    int iIniActNum = iniparser_getint(g_pIni, "SetVideoLostLinkPTZ:actnum", -1);

    NetClient_SetVideoLostLinkPTZ(g_iLogonID, g_iIniChannel, iIniLinkChannel, iIniLinkType, iIniActNum);

    fprintf(stderr, "SetVideoLostLinkPTZ Wait .................. \n");
    usleep(1000*1000);

    // GetVideoLostLinkPTZ
    int iLinkType = 0;
    int iActNum = 0;

    NetClient_GetVideoLostLinkPTZ(g_iLogonID, g_iIniChannel, iIniLinkChannel, &iLinkType, &iActNum);
    if(iLinkType == iIniLinkType &&
       iActNum == iIniActNum)
    {
        fprintf(stderr, "SetVideoLostLinkPTZ GetVideoLostLinkPTZ .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoLostLinkPTZ GetVideoLostLinkPTZ .................. [FAIL]\n");
    }
}

void Auto_SetGetVideoLostLinkSoundDisplay()
{
    // SetVideoLostLinkSoundDisplay
    int iIniSoundEnable = iniparser_getint(g_pIni, "SetVideoLostLinkSoundDisplay:sound_enable", -1);
    int iIniDisplayEnable = iniparser_getint(g_pIni, "SetVideoLostLinkSoundDisplay:display_enable", -1);

    NetClient_SetVideoLostLinkSoundDisplay(g_iLogonID, g_iIniChannel, iIniSoundEnable, iIniDisplayEnable);

    fprintf(stderr, "SetVideoLostLinkSoundDisplay Wait .................. \n");
    usleep(1000*1000);

    // GetVideoLostLinkSoundDisplay
    int iSoundEnable = 0;
    int iDisplayEnable = 0;

    NetClient_GetVideoLostLinkSoundDisplay(g_iLogonID, g_iIniChannel, &iSoundEnable, &iDisplayEnable);
    if(iSoundEnable == iIniSoundEnable &&
       iDisplayEnable == iIniDisplayEnable)
    {
        fprintf(stderr, "SetVideoLostLinkSoundDisplay GetVideoLostLinkSoundDisplay .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoLostLinkSoundDisplay GetVideoLostLinkSoundDisplay .................. [FAIL]\n");
    }
}

void Auto_SetGetVideoLostLinkOutport()
{
    // SetVideoLostLinkOutport
    int iIniOutportArray = iniparser_getint(g_pIni, "SetVideoLostLinkOutport:outport_array", -1);

    NetClient_SetVideoLostLinkOutport(g_iLogonID, g_iIniChannel, iIniOutportArray);

    fprintf(stderr, "SetVideoLostLinkOutport Wait .................. \n");
    usleep(1000*1000);

    // GetVideoLostLinkOutport
    int iOutportArray = 0;

    NetClient_GetVideoLostLinkOutport(g_iLogonID, g_iIniChannel, &iOutportArray);
    if(iOutportArray == iIniOutportArray)
    {
        fprintf(stderr, "SetVideoLostLinkOutport GetVideoLostLinkOutport .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoLostLinkOutport GetVideoLostLinkOutport .................. [FAIL]\n");
    }
}

void Auto_SetGetVideoLostSchedule()
{

    // SetVideoLostSchedule
    int iIniWeekday = iniparser_getint(g_pIni, "SetInportAlarmSchedule:weekday", 0);
    int iIniStartHour = iniparser_getint(g_pIni, "SetInportAlarmSchedule:start_hour", 0);
    int iIniStartMin = iniparser_getint(g_pIni, "SetInportAlarmSchedule:start_min", 0);
    int iIniStopHour = iniparser_getint(g_pIni, "SetInportAlarmSchedule:stop_hour", 0);
    int iIniStopMin = iniparser_getint(g_pIni, "SetInportAlarmSchedule:stop_min", 0);

    NVS_SCHEDTIME timeSeg1,timeSeg2,timeSeg3,timeSeg4;

    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    PNVS_SCHEDTIME schedule[] = {&timeSeg1,&timeSeg2,&timeSeg3,&timeSeg4};

    timeSeg1.iStartHour = iIniStartHour;
    timeSeg1.iStartMin = iIniStartMin;
    timeSeg1.iStopHour = iIniStopHour;
    timeSeg1.iStopMin = iIniStopMin;

    NetClient_SetVideoLostSchedule(g_iLogonID, g_iIniChannel, iIniWeekday, schedule);

    fprintf(stderr, "SetVideoLostSchedule Wait .................. \n");
    usleep(1000*1000);

    // GetVideoLostSchedule
    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    NetClient_GetVideoLostSchedule(g_iLogonID, g_iIniChannel, iIniWeekday, schedule);
    if(timeSeg1.iStartHour == iIniStartHour &&
       timeSeg1.iStartMin == iIniStartMin &&
       timeSeg1.iStopHour == iIniStopHour &&
       timeSeg1.iStopMin == iIniStopMin)
    {
        fprintf(stderr, "SetVideoLostSchedule GetVideoLostSchedule .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoLostSchedule GetVideoLostSchedule .................. [FAIL]\n");
    }

}

void Auto_SetGetVideoLostLinkRec()
{
    // SetVideoLostLinkRec
    int iIniEnable = iniparser_getint(g_pIni, "SetVideoLostLinkRec:enable_bit", -1);

    NetClient_SetVideoLostLinkRec(g_iLogonID, g_iIniChannel, iIniEnable);

    fprintf(stderr, "SetVideoLostLinkRec Wait .................. \n");
    usleep(1000*1000);

    // GetVideoLostLinkRec
    int iEnable = 0;

    NetClient_GetVideoLostLinkRec(g_iLogonID, g_iIniChannel, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetVideoLostLinkRec GetVideoLostLinkRec .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoLostLinkRec GetVideoLostLinkRec .................. [FAIL]\n");
    }
}

void Auto_SetGetVideoLostLinkSnap()
{
    // SetVideoLostLinkSnap
    int iIniEnable = iniparser_getint(g_pIni, "SetVideoLostLinkSnap:enable_bit", -1);

    NetClient_SetVideoLostLinkSnap(g_iLogonID, g_iIniChannel, iIniEnable);

    fprintf(stderr, "SetVideoLostLinkSnap Wait .................. \n");
    usleep(1000*1000);

    // GetVideoLostLinkSnap
    int iEnable = 0;

    NetClient_GetVideoLostLinkSnap(g_iLogonID, g_iIniChannel, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetVideoLostLinkSnap GetVideoLostLinkSnap .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoLostLinkSnap GetVideoLostLinkSnap .................. [FAIL]\n");
    }
}

void Auto_SetGetIFrameRate()
{
    // SetIFrameRate
    int iIniFrameRate = iniparser_getint(g_pIni, "SetIFrameRate:frame_rate", -1);

    NetClient_SetIFrameRate(g_iLogonID, g_iIniChannel, iIniFrameRate, g_iIniStream);

    fprintf(stderr, "SetIFrameRate Wait .................. \n");
    usleep(1000*1000);

    // GetIFrameRate
    int iFrameRate = 0;

    NetClient_GetIFrameRate(g_iLogonID, g_iIniChannel, &iFrameRate, g_iIniStream);
    if(iFrameRate == iIniFrameRate)
    {
        fprintf(stderr, "SetIFrameRate GetIFrameRate .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetIFrameRate GetIFrameRate .................. [FAIL]\n");
    }
}

void Auto_SetGetHTTPPort()
{
    // SetHTTPPort
    int iIniHttpport = iniparser_getint(g_pIni, "SetHTTPPort:http_port", -1);

    NetClient_SetHTTPPort(g_iLogonID, iIniHttpport);

    fprintf(stderr, "SetHTTPPort Wait .................. \n");
    usleep(1000*1000);

    // GetHTTPPort
    int iHttpport = 0;

    NetClient_GetHTTPPort(g_iLogonID, &iHttpport);
    if(iHttpport == iIniHttpport)
    {
        fprintf(stderr, "SetHTTPPort GetHTTPPort .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetHTTPPort GetHTTPPort .................. [FAIL]\n");
    }
}

void Auto_SetGetMaxConUser()
{
    // SetMaxConUser
    int iIniMaxConUser = iniparser_getint(g_pIni, "SetMaxConUser:max_con_user", -1);

    NetClient_SetMaxConUser(g_iLogonID, iIniMaxConUser);

    fprintf(stderr, "SetMaxConUser Wait .................. \n");
    usleep(1000*1000);

    // GetMaxConUser
    int iMaxConUser = 0;

    NetClient_GetMaxGetUser(g_iLogonID, &iMaxConUser);
    if(iMaxConUser == iIniMaxConUser)
    {
        fprintf(stderr, "SetMaxConUser GetMaxConUser .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetMaxConUser GetMaxConUser .................. [FAIL]\n");
    }
}

void Auto_SetGetDHCPParam()
{
    // SetDHCPParam
    int iIniEnable = iniparser_getint(g_pIni, "SetDHCPParam:dhcp_enable", -1);

    NetClient_SetDHCPParam(g_iLogonID, iIniEnable);

    fprintf(stderr, "SetDHCPParam Wait .................. \n");
    usleep(1000*1000);

    // GetDHCPParam
    int iEnable = 0;

    NetClient_GetDHCPParam(g_iLogonID, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetDHCPParam GetDHCPParam .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetDHCPParam GetDHCPParam .................. [FAIL]\n");
    }
}

void Auto_SetGetWifiDHCPParam()
{
    // SetWifiDHCPParam
    int iIniEnable = iniparser_getint(g_pIni, "SetWifiDHCPParam:dhcp_enable", -1);

    NetClient_SetWifiDHCPParam(g_iLogonID, iIniEnable);

    fprintf(stderr, "SetWifiDHCPParam Wait .................. \n");
    usleep(1000*1000);

    // GetWifiDHCPParam
    int iEnable = 0;

    NetClient_GetWifiDHCPParam(g_iLogonID, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetWifiDHCPParam GetWifiDHCPParam .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetWifiDHCPParam GetWifiDHCPParam .................. [FAIL]\n");
    }
}

void Auto_SetGetVideoCovArea()
{
    // SetVideoCovArea
    int iIniLeft = iniparser_getint(g_pIni, "SetVideoCovArea:left", -1);
    int iIniTop = iniparser_getint(g_pIni, "SetVideoCovArea:top", -1);
    int iIniRight = iniparser_getint(g_pIni, "SetVideoCovArea:right", -1);
    int iIniBottom = iniparser_getint(g_pIni, "SetVideoCovArea:bottom", -1);

    RECT rect[4];
    for(int i=0; i<4; i++)
    {
        rect[i].left = 0;
        rect[i].top = 0;
        rect[i].right = 0;
        rect[i].bottom = 0;
    }

    rect[0].left = iIniLeft;
    rect[0].top = iIniTop;
    rect[0].right = iIniRight;
    rect[0].bottom = iIniBottom;

    NetClient_SetVideoCovArea(g_iLogonID, g_iIniChannel, rect, g_iIniStream);

    fprintf(stderr, "SetVideoCovArea Wait .................. \n");
    usleep(1000*1000);

    // GetVideoCovArea
    for(int i=0; i<4; i++)
    {
        rect[i].left = 0;
        rect[i].top = 0;
        rect[i].right = 0;
        rect[i].bottom = 0;
    }

    NetClient_GetVideoCovArea(g_iLogonID, g_iIniChannel, rect, g_iIniStream);
    if(rect[0].left == iIniLeft &&
       rect[0].top == iIniTop &&
       rect[0].right == iIniRight &&
       rect[0].bottom == iIniBottom)
    {
        fprintf(stderr, "SetVideoCovArea GetVideoCovArea .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoCovArea GetVideoCovArea .................. [FAIL]\n");
    }
}

void Auto_SetGetVideoSize()
{
    // SetVideoSize
    int iIniSize = iniparser_getint(g_pIni, "SetVideoSize:size", -1);

    NetClient_SetVideoSize(g_iLogonID, g_iIniChannel, iIniSize, g_iIniStream);

    fprintf(stderr, "SetVideoSize Wait .................. \n");
    usleep(1000*1000);

    // GetVideoSizeEx
    int iSize = 0;

    NetClient_GetVideoSizeEx(g_iLogonID, g_iIniChannel, &iSize, g_iIniStream);
    if(iSize == iIniSize)
    {
        fprintf(stderr, "SetVideoSize GetVideoSizeEx .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoSize GetVideoSizeEx .................. [FAIL]\n");
    }
}

void Auto_SetGetMaxKByteRate()
{
    // SetMaxKByteRate
    int iIniBitRate = iniparser_getint(g_pIni, "SetMaxKByteRate:bit_rate", -1);

    NetClient_SetMaxKByteRate(g_iLogonID, g_iIniChannel, iIniBitRate, g_iIniStream);

    fprintf(stderr, "SetMaxKByteRate Wait .................. \n");
    usleep(1000*1000);

    // GetMaxKByteRate
    int iBitRate = 0;

    NetClient_GetMaxKByteRate(g_iLogonID, g_iIniChannel, &iBitRate, g_iIniStream);
    if(iBitRate == iIniBitRate)
    {
        fprintf(stderr, "SetMaxKByteRate GetMaxKByteRate .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetMaxKByteRate GetMaxKByteRate .................. [FAIL]\n");
    }
}

void Auto_SetGetDomainParsePara()
{
/*
    // SetDomainParsePara
    int iIniInport = iniparser_getint(g_pIni, "SetDomainParsePara:inport", -1);
    int iIniEnable = iniparser_getint(g_pIni, "SetDomainParsePara:enable", -1);

    NetClient_SetDomainParsePara(g_iLogonID, iIniInport, iIniEnable);

    fprintf(stderr, "SetDomainParsePara Wait .................. \n");
    usleep(1000*1000);

    // GetDomainParsePara
    int iEnable = 0;

    NetClient_GetDomainParsePara(g_iLogonID, iIniInport, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetDomainParsePara GetDomainParsePara .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetDomainParsePara GetDomainParsePara .................. [FAIL]\n");
    }
*/
}

void Auto_SetGetReducenoiseState()
{
    // SetReducenoiseState
    int iIniState = iniparser_getint(g_pIni, "SetReducenoiseState:state", -1);

    NetClient_SetReducenoiseState(g_iLogonID, g_iIniChannel, iIniState);

    fprintf(stderr, "SetReducenoiseState Wait .................. \n");
    usleep(1000*1000);

    // GetReducenoiseState
    int iState = 0;

    NetClient_GetReducenoiseState(g_iLogonID, g_iIniChannel, &iState);
    if(iState == iIniState)
    {
        fprintf(stderr, "SetReducenoiseState GetReducenoiseState .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetReducenoiseState GetReducenoiseState .................. [FAIL]\n");
    }
}

void Auto_SetGetBothStreamSame()
{
    // SetBothStreamSame
    int iIniState = iniparser_getint(g_pIni, "SetReducenoiseState:state", -1);

    NetClient_SetBothStreamSame(g_iLogonID, g_iIniChannel, iIniState);

    fprintf(stderr, "SetBothStreamSame Wait .................. \n");
    usleep(1000*1000);

    // GetBothStreamSame
    int iState = 0;

    NetClient_GetBothStreamSame(g_iLogonID, g_iIniChannel, &iState);
    if(iState == iIniState)
    {
        fprintf(stderr, "SetBothStreamSame GetBothStreamSame .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetBothStreamSame GetBothStreamSame .................. [FAIL]\n");
    }
}

void Auto_SetGetPPPoEInfo()
{
    // SetPPPoEInfo
    char *pcIniAccount = iniparser_getstring(g_pIni, "SetPPPoEInfo:account", NULL);
    char *pcIniPassword = iniparser_getstring(g_pIni, "SetPPPoEInfo:password", NULL);
    int iIniEnable = iniparser_getint(g_pIni, "SetPPPoEInfo:enable", -1);

    NetClient_SetPPPoEInfo(g_iLogonID, pcIniAccount, pcIniPassword, iIniEnable);

    fprintf(stderr, "SetPPPoEInfo Wait .................. \n");
    usleep(1000*1000);

    // GetPPPoEInfo
    char cAccount[256] = {0};
    char cPassword[256] = {0};
    int iEnable = 0;

    NetClient_GetPPPoEInfo(g_iLogonID, cAccount, cPassword, &iEnable);
    if(0 == strcmp(pcIniAccount, cAccount) &&
       0 == strcmp(pcIniPassword, cPassword) &&
       iEnable == iIniEnable)
    {
        fprintf(stderr, "SetPPPoEInfo GetPPPoEInfo .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetPPPoEInfo GetPPPoEInfo .................. [FAIL]\n");
    }
}

void Auto_SetGetEncodeMode()
{
    // SetEncodeMode
    int iIniMode = iniparser_getint(g_pIni, "SetEncodeMode:mode", -1);

    NetClient_SetEncodeMode(g_iLogonID, g_iIniChannel, g_iIniStream, iIniMode);

    fprintf(stderr, "SetEncodeMode Wait .................. \n");
    usleep(1000*1000);

    // GetEncodeMode
    int iMode = 0;

    NetClient_GetEncodeMode(g_iLogonID, g_iIniChannel, g_iIniStream, &iMode);
    if(iMode == iIniMode)
    {
        fprintf(stderr, "SetEncodeMode GetEncodeMode .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetEncodeMode GetEncodeMode .................. [FAIL]\n");
    }
}

void Auto_SetGetPreferMode()
{
    // SetPreferMode
    int iIniMode = iniparser_getint(g_pIni, "SetPreferMode:mode", -1);

    NetClient_SetPreferMode(g_iLogonID, g_iIniChannel, g_iIniStream, iIniMode);

    fprintf(stderr, "SetPreferMode Wait .................. \n");
    usleep(1000*1000);

    // GetPreferMode
    int iMode = 0;

    NetClient_GetPreferMode(g_iLogonID, g_iIniChannel, g_iIniStream, &iMode);
    if(iMode == iIniMode)
    {
        fprintf(stderr, "SetPreferMode GetPreferMode .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetPreferMode GetPreferMode .................. [FAIL]\n");
    }
}

void Auto_SetGetVideoNPMode()
{
    // SetVideoNPMode
    VIDEO_NORM viIniMode;
    int iIniMode = iniparser_getint(g_pIni, "SetVideoNPMode:mode", -1);
    viIniMode = (VIDEO_NORM)iIniMode;

    NetClient_SetVideoNPMode(g_iLogonID, viIniMode);

    fprintf(stderr, "SetVideoNPMode Wait .................. \n");
    usleep(1000*1000);

    // GetVideoNPMode
    VIDEO_NORM vMode;

    NetClient_GetVideoNPMode(g_iLogonID, &vMode);
    if(viIniMode == vMode)
    {
        fprintf(stderr, "SetVideoNPMode GetVideoNPMode .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoNPMode GetVideoNPMode .................. [FAIL]\n");
    }
}

void Auto_SetGetAudioEncoder()
{
    // SetAudioEncoder
    int iIniCoder = iniparser_getint(g_pIni, "SetAudioEncoder:coder", -1);
    AUDIO_ENCODER aIniCoder = (AUDIO_ENCODER)iIniCoder;

    NetClient_SetAudioEncoder(g_iLogonID, g_iIniChannel, aIniCoder);

    fprintf(stderr, "SetAudioEncoder Wait .................. \n");
    usleep(1000*1000);

    // GetAudioEncoder
    AUDIO_ENCODER aCoder;

    NetClient_GetAudioEncoder(g_iLogonID, g_iIniChannel, &aCoder);
    if(aIniCoder == aCoder)
    {
        fprintf(stderr, "SetAudioEncoder GetAudioEncoder .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetAudioEncoder GetAudioEncoder .................. [FAIL]\n");
    }
}

void Auto_SetGetMediaStreamClient()
{
    // SetMediaStreamClient
    char *pcIniClientIP = iniparser_getstring(g_pIni, "SetMediaStreamClient:client_ip", NULL);
    int iIniClientPort = iniparser_getint(g_pIni, "SetMediaStreamClient:client_port", -1);
    int iIniStreamType = iniparser_getint(g_pIni, "SetMediaStreamClient:stream_type", -1);

    NetClient_SetMediaStreamClient(g_iLogonID, g_iIniChannel, pcIniClientIP, iIniClientPort, iIniStreamType);

    fprintf(stderr, "SetMediaStreamClient Wait .................. \n");
    usleep(1000*1000);

    // GetMediaStreamClient
    char cClientIP[256] = {0};
    unsigned short uPort = 0;
    int iStreamType = 0;

    NetClient_GetMediaStreamClient(g_iLogonID, g_iIniChannel, cClientIP, &uPort, &iStreamType);
    if(uPort == (unsigned short)iIniClientPort &&
       iStreamType == iIniStreamType &&
       0 == strcmp(cClientIP, pcIniClientIP))
    {
        fprintf(stderr, "SetMediaStreamClient GetMediaStreamClient .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetMediaStreamClient GetMediaStreamClient .................. [FAIL]\n");
    }
}

void Auto_SetGetEmailAlarm()
{
/*
    // SetEmailAlarm
    int iIniInport = iniparser_getint(g_pIni, "SetEmailAlarm:inport", -1);
    int iIniEnable = iniparser_getint(g_pIni, "SetEmailAlarm:enable", -1);

    NetClient_SetEmailAlarm(g_iLogonID, iIniInport, iIniEnable);

    fprintf(stderr, "SetEmailAlarm Wait .................. \n");
    usleep(1000*1000);

    // GetEmailAlarm
    int iEnable = 0;

    NetClient_GetEmailAlarm(g_iLogonID, iIniInport, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetEmailAlarm GetEmailAlarm .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetEmailAlarm GetEmailAlarm .................. [FAIL]\n");
    }
*/
}

void Auto_SetGetEmailAlarmEnable()
{
    // SetEmailAlarmEnable
    int iIniEnable = iniparser_getint(g_pIni, "SetEmailAlarmEnable:enable", -1);

    NetClient_SetEmailAlarmEnable(g_iLogonID, g_iIniChannel, iIniEnable);

    fprintf(stderr, "SetEmailAlarmEnable Wait .................. \n");
    usleep(1000*1000);

    // GetEmailAlarmEnable
    int iEnable = 0;

    NetClient_GetEmailAlarmEnable(g_iLogonID, g_iIniChannel, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetEmailAlarmEnable GetEmailAlarmEnable .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetEmailAlarmEnable GetEmailAlarmEnable .................. [FAIL]\n");
    }
}

void Auto_SetGetScene()
{
    // SetScene
    int iIniScene = iniparser_getint(g_pIni, "SetScene:scene", -1);

    NetClient_SetScene(g_iLogonID, g_iIniChannel, iIniScene);

    fprintf(stderr, "SetScene Wait .................. \n");
    usleep(1000*1000);

    // GetScene
    int iScene = 0;

    NetClient_GetScene(g_iLogonID, g_iIniChannel, &iScene);
    if(iScene == iIniScene)
    {
        fprintf(stderr, "SetScene GetScene .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetScene GetScene .................. [FAIL]\n");
    }
}

void Auto_SetGetSensorFlip()
{
    // SetSensorFlip
    int iIniFlip = iniparser_getint(g_pIni, "SetSensorFlip:flip", -1);

    NetClient_SetSensorFlip(g_iLogonID, g_iIniChannel, iIniFlip);

    fprintf(stderr, "SetSensorFlip Wait .................. \n");
    usleep(1000*1000);

    // GetSensorFlip
    int iFlip = 0;

    NetClient_GetSensorFlip(g_iLogonID, g_iIniChannel, &iFlip);
    if(iFlip == iIniFlip)
    {
        fprintf(stderr, "SetSensorFlip GetSensorFlip .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetSensorFlip GetSensorFlip .................. [FAIL]\n");
    }
}

void Auto_SetGetSensorMirror()
{
    // SetSensorMirror
    int iIniMirror = iniparser_getint(g_pIni, "SetSensorMirror:mirror", -1);

    NetClient_SetSensorMirror(g_iLogonID, g_iIniChannel, iIniMirror);

    fprintf(stderr, "SetSensorMirror Wait .................. \n");
    usleep(1000*1000);

    // GetSensorMirror
    int iMirror = 0;

    NetClient_GetSensorMirror(g_iLogonID, g_iIniChannel, &iMirror);
    if(iMirror == iIniMirror)
    {
        fprintf(stderr, "SetSensorMirror GetSensorMirror .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetSensorMirror GetSensorMirror .................. [FAIL]\n");
    }
}

void Auto_SetGetWifiParam()
{
    // SetWifiParam
    char *pcIniServer = iniparser_getstring(g_pIni, "SetWifiParam:server", NULL);
    char *pcIniMask = iniparser_getstring(g_pIni, "SetWifiParam:mask", NULL);
    char *pcIniGateway = iniparser_getstring(g_pIni, "SetWifiParam:gateway", NULL);
    char *pcIniDNS = iniparser_getstring(g_pIni, "SetWifiParam:dns", NULL);
    char *pcIniEssid = iniparser_getstring(g_pIni, "SetWifiParam:essid", NULL);
    char *pcIniEncry = iniparser_getstring(g_pIni, "SetWifiParam:encryption", NULL);
    char *pcIniPassword = iniparser_getstring(g_pIni, "SetWifiParam:password", NULL);
    char *pcIniKeyType = iniparser_getstring(g_pIni, "SetWifiParam:key_type", NULL);
    char *pcIniKeyNum = iniparser_getstring(g_pIni, "SetWifiParam:key_num", NULL);

    NVS_WIFI_PARAM wifiParam;
    memset(&wifiParam, 0, sizeof(wifiParam));
    strcpy(wifiParam.cWifiSvrIP, pcIniServer); 
    strcpy(wifiParam.cWifiMask, pcIniMask);
    strcpy(wifiParam.cWifiGateway, pcIniGateway);
    strcpy(wifiParam.cWifiDNS, pcIniDNS);
    strcpy(wifiParam.cESSID, pcIniEssid);
    strcpy(wifiParam.cEncryption, pcIniEncry);
    strcpy(wifiParam.cWifiPassword, pcIniPassword);
    strcpy(wifiParam.cWifiKeyType, pcIniKeyType);
    strcpy(wifiParam.cWifiKeyNum, pcIniKeyNum);

    NetClient_SetWifiParam(g_iLogonID, &wifiParam);

    fprintf(stderr, "SetWifiParam Wait .................. \n");
    usleep(1000*1000);

    // GetWifiParam
    memset(&wifiParam, 0, sizeof(wifiParam));

    NetClient_GetWifiParam(g_iLogonID, &wifiParam); 
    if( 0 == strcmp(wifiParam.cWifiSvrIP, pcIniServer) && 
        0 == strcmp(wifiParam.cWifiMask, pcIniMask) &&
        0 == strcmp(wifiParam.cWifiGateway, pcIniGateway) &&
        0 == strcmp(wifiParam.cWifiDNS, pcIniDNS) &&
        0 == strcmp(wifiParam.cESSID, pcIniEssid) &&
        0 == strcmp(wifiParam.cEncryption, pcIniEncry) &&
        0 == strcmp(wifiParam.cWifiKeyType, pcIniKeyType)&&
        0 == strcmp(wifiParam.cWifiKeyNum, pcIniKeyNum))
    {
        fprintf(stderr, "SetWifiParam GetWifiParam .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetWifiParam GetWifiParam .................. [FAIL]\n");
    }
}

void Auto_SetGetPrivacyProtect()
{
    // SetPrivacyProtect
    int iIniEnable = iniparser_getint(g_pIni, "SetPrivacyProtect:enable", -1);

    NetClient_SetPrivacyProtect(g_iLogonID, g_iIniChannel, iIniEnable);

    fprintf(stderr, "SetPrivacyProtect Wait .................. \n");
    usleep(1000*1000);

    // GetPrivacyProtect
    int iEnable = 0;

    NetClient_GetPrivacyProtect(g_iLogonID, g_iIniChannel, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetPrivacyProtect GetPrivacyProtect .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetPrivacyProtect GetPrivacyProtect .................. [FAIL]\n");
    }
}

void Auto_SetGetUPNPEnable()
{
    // SetUPNPEnable
    int iIniEnable = iniparser_getint(g_pIni, "SetUPNPEnable:enable", -1);

    NetClient_SetUPNPEnable(g_iLogonID, iIniEnable);

    fprintf(stderr, "SetUPNPEnable Wait .................. \n");
    usleep(1000*1000);

    // GetUPNPEnable
    int iEnable = 0;

    NetClient_GetUPNPEnable(g_iLogonID, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetUPNPEnable GetUPNPEnable .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetUPNPEnable GetUPNPEnable .................. [FAIL]\n");
    }
}

void Auto_SetGetDDNSPara()
{
//  // SetDDNSPara
//  int iIniInport = iniparser_getint(g_pIni, "SetDDNSPara:inport", -1);
//  int iIniEnable = iniparser_getint(g_pIni, "SetDDNSPara:enable", -1);
//
//  NetClient_SetDDNSPara(g_iLogonID, iIniInport, iIniEnable);
//
//  fprintf(stderr, "SetDDNSPara Wait .................. \n");
//  usleep(1000*1000);
//
//  // GetDDNSPara
//  int iEnable = 0;
//
//  NetClient_GetDDNSPara(g_iLogonID, iIniInport, &iEnable);
//  if(iEnable == iIniEnable)
//  {
//      fprintf(stderr, "SetDDNSPara GetDDNSPara .................. [OK]\n");
//  }
//  else
//  {
//      fprintf(stderr, "SetDDNSPara GetDDNSPara .................. [FAIL]\n");
//  }
}

void Auto_SetGetFuncListArray()
{
    // SetFuncListArray
    int iIniArray = iniparser_getint(g_pIni, "SetFuncListArray:enable_array", -1);


    NetClient_SetFuncListArray(g_iLogonID, iIniArray);

    fprintf(stderr, "SetFuncListArray Wait .................. \n");
    usleep(1000*1000);

    // GetFuncListArray
    int iArray = 0;

    NetClient_GetFuncListArray(g_iLogonID, &iArray);
    if(iArray == iIniArray)
    {
        fprintf(stderr, "SetFuncListArray GetFuncListArray .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetFuncListArray GetFuncListArray .................. [FAIL]\n");
    }
}

void Auto_SetGetVencType()
{
    // SetVencType
    int iIniType = iniparser_getint(g_pIni, "SetVencType:type", -1);

    NetClient_SetVencType(g_iLogonID, g_iIniChannel, iIniType);

    fprintf(stderr, "SetVencType Wait .................. \n");
    usleep(1000*1000);

    // GetVencType
    int iType = 0;

    NetClient_GetVencType(g_iLogonID, g_iIniChannel, &iType);
    if(iType == iIniType)
    {
        fprintf(stderr, "SetVencType GetVencType .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVencType GetVencType .................. [FAIL]\n");
    }
}

void Auto_SetGetComServer()
{
    // SetComServer
    char *pcIniComServer = iniparser_getstring(g_pIni, "SetComServer:com_server", NULL);
    int iIniComPort = iniparser_getint(g_pIni, "SetComServer:com_port", -1);

    NetClient_SetComServer(g_iLogonID, pcIniComServer, iIniComPort);

    fprintf(stderr, "SetComServer Wait .................. \n");
    usleep(1000*1000);

    // GetComServer
    char cComServer[256] = {0};
    int iComPort = 0;

    NetClient_GetComServer(g_iLogonID, cComServer, &iComPort);
    if(iComPort == iIniComPort &&
       0 == strcmp(pcIniComServer, cComServer))
    {
        fprintf(stderr, "SetComServer GetComServer .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetComServer GetComServer .................. [FAIL]\n");
    }
}

void Auto_SetGet3GDialog()
{
    // Set3GDialog
    int iIniStartType = iniparser_getint(g_pIni, "Set3GDialog:start_type", -1);
    int iIniStopType = iniparser_getint(g_pIni, "Set3GDialog:stop_type", -1);
    int iIniDuration = iniparser_getint(g_pIni, "Set3GDialog:duration", -1);

    NetClient_Set3GDialog(g_iLogonID, iIniStartType, iIniStopType, iIniDuration);

    fprintf(stderr, "Set3GDialog Wait .................. \n");
    usleep(1000*1000);

    // Get3GDialog
    int iStartType = 0;
    int iStopType = 0;
    int iDuration = 0;

    NetClient_Get3GDialog(g_iLogonID, &iStartType, &iStopType, &iDuration);
    if(iStartType == iIniStartType &&
       iStopType == iIniStopType &&
       iDuration == iIniDuration)
    {
        fprintf(stderr, "Set3GDialog Get3GDialog .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "Set3GDialog Get3GDialog .................. [FAIL]\n");
    }
}

void Auto_SetGet3GMessage()
{
    // Set3GMessage
    char *pcIniNotify = iniparser_getstring(g_pIni, "Set3GMessage:notify", NULL);
    char *pcIniPhone = iniparser_getstring(g_pIni, "Set3GMessage:phonenum", NULL);

    NetClient_Set3GMessage(g_iLogonID, pcIniNotify, pcIniPhone, NULL, NULL, NULL, NULL);

    fprintf(stderr, "Set3GMessage Wait .................. \n");
    usleep(1000*1000);

    // Get3GMessage
    char cNotify[256] = {0};
    char cPhone[256] = {0};

    NetClient_Get3GMessage(g_iLogonID, cNotify, cPhone, NULL, NULL, NULL, NULL);
    if(0 == strcmp(cNotify, pcIniNotify) &&
       0 == strcmp(cPhone, pcIniPhone))
    {
        fprintf(stderr, "Set3GMessage Get3GMessage .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "Set3GMessage Get3GMessage .................. [FAIL]\n");
    }
}

void Auto_SetGet3GTaskSchedule()
{
    // Set3GTaskSchedule
    int iIniOnlineOrNot = iniparser_getint(g_pIni, "Set3GTaskSchedule:online_or_not", 0);
    int iIniStartHour = iniparser_getint(g_pIni, "SetInportAlarmSchedule:start_hour", 0);
    int iIniStartMin = iniparser_getint(g_pIni, "SetInportAlarmSchedule:start_min", 0);
    int iIniStopHour = iniparser_getint(g_pIni, "SetInportAlarmSchedule:stop_hour", 0);
    int iIniStopMin = iniparser_getint(g_pIni, "SetInportAlarmSchedule:stop_min", 0);

    NVS_SCHEDTIME timeSeg;
    memset(&timeSeg, 0, sizeof(NVS_SCHEDTIME));

    timeSeg.iStartHour = iIniStartHour;
    timeSeg.iStartMin = iIniStartMin;
    timeSeg.iStopHour = iIniStopHour;
    timeSeg.iStopMin = iIniStopMin;

    NetClient_Set3GTaskSchedule(g_iLogonID, iIniOnlineOrNot, &timeSeg);

    fprintf(stderr, "Set3GTaskSchedule Wait .................. \n");
    usleep(1000*1000);

    // Get3GTaskSchedule
    int iOnlineOrNot = 0;
    memset(&timeSeg, 0, sizeof(NVS_SCHEDTIME));

    NetClient_Get3GTaskSchedule(g_iLogonID, &iOnlineOrNot, &timeSeg);
    if(iOnlineOrNot == iIniOnlineOrNot &&
       timeSeg.iStartHour == iIniStartHour &&
       timeSeg.iStartMin == iIniStartMin &&
       timeSeg.iStopHour == iIniStopHour &&
       timeSeg.iStopMin == iIniStopMin)
    {
        fprintf(stderr, "Set3GTaskSchedule Get3GTaskSchedule .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "Set3GTaskSchedule Get3GTaskSchedule .................. [FAIL]\n");
    }
}

void Auto_SetGet3GNotify()
{
    // Set3GNotify
    int iIniType = iniparser_getint(g_pIni, "Set3GNotify:type", -1);
    char *pcIniMessage = iniparser_getstring(g_pIni, "Set3GNotify:message", NULL);

    NetClient_Set3GNotify(g_iLogonID, iIniType, pcIniMessage);

    fprintf(stderr, "Set3GNotify Wait .................. \n");
    usleep(1000*1000);

    // Get3GNotify
    int iType = 0;
    char cMessage[256] = {0};

    NetClient_Get3GNotify(g_iLogonID, &iType, cMessage);
    if(iType == iIniType &&
       0 == strcmp(cMessage, pcIniMessage))
    {
        fprintf(stderr, "Set3GNotify Get3GNotify .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "Set3GNotify Get3GNotify .................. [FAIL]\n");
    }
}

void Auto_SetGetHDCamer()
{
    // SetHDCamer
    int iIniFuncNum = iniparser_getint(g_pIni, "SetHDCamer:func_num", -1);
    int iIniValue = iniparser_getint(g_pIni, "SetHDCamer:value", -1);

    NetClient_SetHDCamer(g_iLogonID, g_iIniChannel, iIniFuncNum, iIniValue);

    fprintf(stderr, "SetHDCamer Wait .................. \n");
    usleep(1000*1000);

    // GetHDCamer
    int iValue = 0;

    NetClient_GetHDCamer(g_iLogonID, g_iIniChannel, iIniFuncNum, &iValue);
    if(iValue == iIniValue)
    {
        fprintf(stderr, "SetHDCamer GetHDCamer .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetHDCamer GetHDCamer .................. [FAIL]\n");
    }
}

void Auto_SetGetAlarmServer()
{
    // SetAlarmServer
    char *pcIniServer = iniparser_getstring(g_pIni, "SetAlarmServer:server", NULL);
    int iIniPort = iniparser_getint(g_pIni, "SetAlarmServer:port", -1);

    NetClient_SetAlarmServer(g_iLogonID, pcIniServer, iIniPort);

    fprintf(stderr, "SetAlarmServer Wait .................. \n");
    usleep(1000*1000);

    // GetAlarmServer
    char cServer[256] = {0};
    int iPort = 0;

    NetClient_GetAlarmServer(g_iLogonID, cServer, &iPort);
    if(iPort == iIniPort &&
       0 == strcmp(cServer, pcIniServer))
    {
        fprintf(stderr, "SetAlarmServer GetAlarmServer .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetAlarmServer GetAlarmServer .................. [FAIL]\n");
    }
}

void Auto_WriteReadUserData()
{
    // WriteUserData
    char *pcIniData = iniparser_getstring(g_pIni, "WriteUserData:data", NULL);
    int iIniOffset = iniparser_getint(g_pIni, "WriteUserData:offset", -1);
    int iIniLen = iniparser_getint(g_pIni, "WriteUserData:len", -1);

    NetClient_WriteUserData(g_iLogonID, iIniOffset, (unsigned char*)pcIniData, iIniLen);

    fprintf(stderr, "WriteUserData Wait .................. \n");
    usleep(1000*1000);

    // ReadUserData
    char cData[256] = {0};
    int iLen = 32;

    NetClient_ReadUserData(g_iLogonID, iIniOffset, (unsigned char*)cData, iLen);
    if(0 == strcmp(cData, pcIniData))
    {
        fprintf(stderr, "WriteUserData ReadUserData .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "WriteUserData ReadUserData .................. [FAIL]\n");
    }
}

void Auto_DrawGetTextOnVideo()
{
    // DrawTextOnVideo
    char *pcIniText = iniparser_getstring(g_pIni, "DrawTextOnVideo:text", NULL);
    int iIniXPos = iniparser_getint(g_pIni, "DrawTextOnVideo:xPos", -1);
    int iIniYPos = iniparser_getint(g_pIni, "DrawTextOnVideo:yPos", -1);
    int iIniEnable = iniparser_getint(g_pIni, "DrawTextOnVideo:store_enable", -1);

    NetClient_DrawTextOnVideo(g_iLogonID, g_iIniChannel, iIniXPos, iIniYPos, pcIniText, iIniEnable, g_iIniStream);

    fprintf(stderr, "WriteUserData Wait .................. \n");
    usleep(1000*1000);

    // GetTextOnVideo
    char cText[256] = {0};
    int iXPos = 0;
    int iYPos = 0;

    NetClient_GetTextOnVideo(g_iLogonID, g_iIniChannel, &iXPos, &iYPos, cText, g_iIniStream);
    if(iXPos == iIniXPos &&
       iYPos == iIniYPos &&
       0 == strcmp(cText, pcIniText))
    {
        fprintf(stderr, "DrawTextOnVideo GetTextOnVideo .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "DrawTextOnVideo GetTextOnVideo .................. [FAIL]\n");
    }
}

void Auto_ShowGetBitrateOnVideo()
{
//  // ShowBitrateOnVideo
//  char *pcIniText = iniparser_getstring(g_pIni, "ShowBitrateOnVideo:text", NULL);
//  int iIniXPos = iniparser_getint(g_pIni, "ShowBitrateOnVideo:xPos", -1);
//  int iIniYPos = iniparser_getint(g_pIni, "ShowBitrateOnVideo:yPos", -1);
//  int iIniEnable = iniparser_getint(g_pIni, "ShowBitrateOnVideo:store_enable", -1);
//
//  NetClient_ShowBitrateOnVideo(g_iLogonID, iIniOffset, (unsigned char*)pcIniData, iIniLen);
//
//  fprintf(stderr, "ShowBitrateOnVideo Wait .................. \n");
//  usleep(1000*1000);
//
//  // GetBitrateOnVideo
//  char cText[256] = {0};
//  int iXPos = 0;
//  int iYPos = 0;
//
//  NetClient_GetBitrateOnVideo(g_iLogonID, g_iIniChannel, &iXPos, &iYPos, cText, g_iIniStream);
//  if(iXPos == iIniXPos &&
//     iYPos == iIniYPos &&
//     0 == strcmp(cText, pcIniText))
//  {
//      fprintf(stderr, "ShowBitrateOnVideo GetBitrateOnVideo .................. [OK]\n");
//  }
//  else
//  {
//      fprintf(stderr, "ShowBitrateOnVideo GetBitrateOnVideo .................. [FAIL]\n");
//  }
}

void Auto_LogFileSetGetProperty()
{
    // LogFileSetProperty
    int iIniLevel = iniparser_getint(g_pIni, "LogFileSetProperty:level", -1);
    int iIniSize = iniparser_getint(g_pIni, "LogFileSetProperty:size", -1);

    NetClient_LogFileSetProperty(g_iLogonID, iIniLevel, iIniSize);

    fprintf(stderr, "LogFileSetProperty Wait .................. \n");
    usleep(1000*1000);

    // LogFileGetProperty
    int iLevel = 0;
    int iSize = 0;

    NetClient_LogFileGetProperty(g_iLogonID, &iLevel, &iSize);
    if(iLevel == iIniLevel &&
       iSize == iIniSize)
    {
        fprintf(stderr, "LogFileSetProperty LogFileGetProperty .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "LogFileSetProperty LogFileGetProperty .................. [FAIL]\n");
    }
}

void Auto_NetFileSetGetRecordRule()
{
    // NetFileSetRecordRule
    int iIniRule = iniparser_getint(g_pIni, "NetFileSetRecordRule:rule", -1);
    int iIniTimeLen = iniparser_getint(g_pIni, "NetFileSetRecordRule:time_len", -1);
    int iIniFreeDisk = iniparser_getint(g_pIni, "NetFileSetRecordRule:free_disk", -1);
    int iIniFileSize = iniparser_getint(g_pIni, "NetFileSetRecordRule:file_size", -1);

    NetClient_NetFileSetRecordRule(g_iLogonID, iIniRule, iIniTimeLen, iIniFreeDisk, iIniFileSize);

    fprintf(stderr, "NetFileSetRecordRule Wait .................. \n");
    usleep(1000*1000);

    // NetFileGetRecordRule
    int iRule = 0;
    int iTimeLen = 0;
    int iFreeDisk = 0;
    int iFileSize = 0;

    NetClient_NetFileGetRecordRule(g_iLogonID, &iRule, &iTimeLen, &iFreeDisk, &iFileSize);
    if(iRule == iIniRule &&
       iTimeLen == iIniTimeLen &&
       iFreeDisk == iIniFreeDisk &&
       iFileSize == iIniFileSize)
    {
        fprintf(stderr, "NetFileSetRecordRule NetFileGetRecordRule .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "NetFileSetRecordRule NetFileGetRecordRule .................. [FAIL]\n");
    }
}

void Auto_NetFileSetGetAlarmRule()
{
    // NetFileSetAlarmRule
    int iIniPrerecordEnable = iniparser_getint(g_pIni, "NetFileSetAlarmRule:pre_record_enable", -1);
    int iIniPrerecordTime = iniparser_getint(g_pIni, "NetFileSetAlarmRule:pre_record_time", -1);
    int iIniDelayTime = iniparser_getint(g_pIni, "NetFileSetAlarmRule:delay_time", -1);
    int iIniDelayEnable = 1;

    NetClient_NetFileSetAlarmRule(g_iLogonID,
				  iIniPrerecordEnable,
				  iIniPrerecordTime,
				  iIniDelayTime,
				  iIniDelayEnable,
				  g_iIniChannel);

    fprintf(stderr, "NetFileSetAlarmRule Wait .................. \n");
    usleep(1000*1000);

    // NetFileGetAlarmRule
    int iPreEnable = 0;
    int iPreTime = 0;
    int iDelayTime = 0;
    int iDelayEnable = 0;

    NetClient_NetFileGetAlarmRule(g_iLogonID, &iPreEnable, &iPreTime, &iDelayTime, &iDelayEnable, g_iIniChannel);
    if(iPreEnable == iIniPrerecordEnable &&
       iPreTime == iIniPrerecordTime &&
       iDelayTime == iIniDelayTime)
    {
        fprintf(stderr, "NetFileSetAlarmRule NetFileGetAlarmRule .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "NetFileSetAlarmRule NetFileGetAlarmRule .................. [FAIL]\n");
    }
}

void Auto_NetFileSetGetAlarmState()
{
    // NetFileSetAlarmState
    int iIniState = iniparser_getint(g_pIni, "NetFileSetAlarmState:state", -1);

    NetClient_NetFileSetAlarmState(g_iLogonID, g_iIniChannel, iIniState);

    fprintf(stderr, "NetFileSetAlarmState Wait .................. \n");
    usleep(1000*1000);

    // NetFileGetAlarmState
    int iState = 0;

    NetClient_NetFileGetAlarmState(g_iLogonID, g_iIniChannel, &iState);
    if(iState == iIniState)
    {
        fprintf(stderr, "NetFileSetAlarmState NetFileGetAlarmState .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "NetFileSetAlarmState NetFileGetAlarmState .................. [FAIL]\n");
    }
}

void Auto_NetFileSetGetTaskState()
{
    // NetFileSetTaskState
    int iIniState = iniparser_getint(g_pIni, "NetFileSetTaskState:state", -1);

    NetClient_NetFileSetTaskState(g_iLogonID, g_iIniChannel, iIniState);

    fprintf(stderr, "NetFileSetTaskState Wait .................. \n");
    usleep(1000*1000);

    // NetFileGetTaskState
    int iState = 0;

    NetClient_NetFileGetAlarmState(g_iLogonID, g_iIniChannel, &iState);
    if(iState == iIniState)
    {
        fprintf(stderr, "NetFileSetTaskState NetFileGetTaskState .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "NetFileSetTaskState NetFileGetTaskState .................. [FAIL]\n");
    }
}

void Auto_NetFileSetGetTaskSchedule()
{
    // NetFileSetTaskSchedule
    int iIniWeekday = iniparser_getint(g_pIni, "NetFileSetTaskSchedule:weekday", 0);
    int iIniStartHour = iniparser_getint(g_pIni, "NetFileSetTaskSchedule:start_hour", 0);
    int iIniStartMin = iniparser_getint(g_pIni, "NetFileSetTaskSchedule:start_min", 0);
    int iIniStopHour = iniparser_getint(g_pIni, "NetFileSetTaskSchedule:stop_hour", 0);
    int iIniStopMin = iniparser_getint(g_pIni, "NetFileSetTaskSchedule:stop_min", 0);

    NVS_SCHEDTIME timeSeg1,timeSeg2,timeSeg3,timeSeg4;

    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    PNVS_SCHEDTIME schedule[] = {&timeSeg1,&timeSeg2,&timeSeg3,&timeSeg4};

    timeSeg1.iStartHour = iIniStartHour;
    timeSeg1.iStartMin = iIniStartMin;
    timeSeg1.iStopHour = iIniStopHour;
    timeSeg1.iStopMin = iIniStopMin;

    NetClient_NetFileSetTaskSchedule(g_iLogonID, g_iIniChannel, iIniWeekday, schedule);

    fprintf(stderr, "NetFileSetTaskSchedule Wait .................. \n");
    usleep(1000*1000);

    // NetFileGetTaskSchedule
    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    NetClient_NetFileGetTaskSchedule(g_iLogonID, g_iIniChannel, iIniWeekday, schedule);
    if(timeSeg1.iStartHour == iIniStartHour &&
       timeSeg1.iStartMin == iIniStartMin &&
       timeSeg1.iStopHour == iIniStopHour &&
       timeSeg1.iStopMin == iIniStopMin)
    {
        fprintf(stderr, "NetFileSetTaskSchedule NetFileGetTaskSchedule .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "NetFileSetTaskSchedule NetFileGetTaskSchedule .................. [FAIL]\n");
    }

}

void Auto_NetFileSetGetMapStoreDevice()
{
    // NetFileMapStoreDevice
    char *pcIniIP = iniparser_getstring(g_pIni, "NetFileMapStoreDevice:IP", NULL);
    char *pcIniPath = iniparser_getstring(g_pIni, "NetFileMapStoreDevice:path", NULL);

    NVS_NFS_DEV storeDev;
    memset(&storeDev, 0, sizeof(storeDev));

    strcpy(storeDev.cDeviceIP, pcIniIP);
    strcpy(storeDev.cStorePath, pcIniPath);

    NetClient_NetFileMapStoreDevice(g_iLogonID, &storeDev);

    fprintf(stderr, "NetFileMapStoreDevice Wait .................. \n");
    usleep(1000*1000);

    // NetFileGetMapStoreDevice
    memset(&storeDev, 0, sizeof(storeDev));

    NetClient_NetFileGetMapStoreDevice(g_iLogonID, &storeDev);
    if(0 == strcmp(storeDev.cDeviceIP, pcIniIP) &&
       0 == strcmp(storeDev.cStorePath, pcIniPath))
    {
        fprintf(stderr, "NetFileMapStoreDevice NetFileGetMapStoreDevice .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "NetFileMapStoreDevice NetFileGetMapStoreDevice .................. [FAIL]\n");
    }
}

void Auto_NetFileSetGetExtendname()
{
    // NetFileSetExtendname
    char *pcIniExtendName = iniparser_getstring(g_pIni, "NetFileSetExtendname:extend_name", NULL);

    NetClient_NetFileSetExtendname(g_iLogonID, pcIniExtendName);

    fprintf(stderr, "NetFileSetExtendname Wait .................. \n");
    usleep(1000*1000);

    // NetFileGetExtendname
    char cExtendName[256] = {0};

    NetClient_NetFileGetExtendname(g_iLogonID, cExtendName);
    if(0 == strcmp(pcIniExtendName, cExtendName))
    {
        fprintf(stderr, "NetFileSetExtendname NetFileGetExtendname .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "NetFileSetExtendname NetFileGetExtendname .................. [FAIL]\n");
    }
}

void Auto_SetGetEmailAlarmEx()
{
    char *pcSmtpIP          = iniparser_getstring(g_pIni, "SetEmailAlarmEx:ip", NULL);
    int  iPort              = iniparser_getint(g_pIni, "SetEmailAlarmEx:port", -1);
    char *pcAccountName     = iniparser_getstring(g_pIni, "SetEmailAlarmEx:accountname", NULL);
    char *pcAccountPassword = iniparser_getstring(g_pIni, "SetEmailAlarmEx:password", NULL);
    int  iAuthType          = iniparser_getint(g_pIni, "SetEmailAlarmEx:authtype", -1);
    char *pcEmailAddress    = iniparser_getstring(g_pIni, "SetEmailAlarmEx:emailaddress", NULL);
    char *pcSubject         = iniparser_getstring(g_pIni, "SetEmailAlarmEx:subject", NULL);
    char *pcExtraAccount1   = iniparser_getstring(g_pIni, "SetEmailAlarmEx:extraaccount1", NULL);
    char *pcExtraAccount2   = iniparser_getstring(g_pIni, "SetEmailAlarmEx:extraaccount2", NULL);
    char *pcExtraAccount3   = iniparser_getstring(g_pIni, "SetEmailAlarmEx:extraaccount3", NULL);

    SMTP_INFOEX smtpEx;
    memset(&smtpEx, 0, sizeof(smtpEx));
    strcpy(smtpEx.smtpInfo.cSmtpServer, pcSmtpIP);
    smtpEx.smtpInfo.wdSmtpPort = iPort;
    strcpy(smtpEx.smtpInfo.cEmailAccount, pcAccountName);
    strcpy(smtpEx.smtpInfo.cEmailPassword, pcAccountPassword);
    smtpEx.smtpInfo.iAuthtype = iAuthType;
    strcpy(smtpEx.smtpInfo.cEmailAddress, pcEmailAddress);
    strcpy(smtpEx.smtpInfo.cMailSubject, pcSubject);
    strcpy(smtpEx.cMailAddr[0], pcExtraAccount1);
    strcpy(smtpEx.cMailAddr[1], pcExtraAccount2);
    strcpy(smtpEx.cMailAddr[2], pcExtraAccount3);

    NetClient_SetEmailAlarmEx(g_iLogonID, (PSMTP_INFO)&smtpEx, sizeof(SMTP_INFOEX));

    fprintf(stderr, "SetEmailAlarmEx Wait .................. \n");
    usleep(1000*1000);
    memset(&smtpEx, 0, sizeof(smtpEx));
    
    NetClient_GetEmailAlarmEx(g_iLogonID, (PSMTP_INFO)&smtpEx, sizeof(SMTP_INFOEX));

    if( 0 == strcmp(smtpEx.smtpInfo.cSmtpServer, pcSmtpIP) && iPort == smtpEx.smtpInfo.wdSmtpPort &&
        0 == strcmp(smtpEx.smtpInfo.cEmailAccount, pcAccountName) && 0 == strcmp(smtpEx.smtpInfo.cEmailPassword, pcAccountPassword) &&
        iAuthType == smtpEx.smtpInfo.iAuthtype && 0 == strcmp(smtpEx.smtpInfo.cEmailAddress, pcEmailAddress) &&
        0 == strcmp(smtpEx.smtpInfo.cMailSubject, pcSubject) && 0 == strcmp(smtpEx.cMailAddr[0], pcExtraAccount1) &&
        0 == strcmp(smtpEx.cMailAddr[1], pcExtraAccount2) && 0 == strcmp(smtpEx.cMailAddr[2], pcExtraAccount3))
    {
        fprintf(stderr, "SetEmailAlarmEx GetEmailAlarmEx .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetEmailAlarmEx GetEmailAlarmEx .................. [FAIL]\n");
    }
}

void Auto_SetGetFTPUploadConfig()
{
    FTP_SNAPSHOT snapshot = {0};
    FTP_LINKSEND linkSend = {0};
    FTP_TIMEDSEND timeSend = {0};
    FTP_UPDATE update;
    memset(&update, 0, sizeof(update));
    int iSnapShotChannel = -1;
    int iSnapShotEnable  = -1;
    int iSnapShotInterval= -1;
    int iSnapShotQValue  = -1;

    int iLinkSendChannel = -1;
    int iLinkSendEnable  = -1;
    int iLinkSendMethod  = -1;

    int iTimeSendChannel = -1;
    int iTimeSendEnable  = -1;
    int iTimeSendFileType= -1;
    int iTimeSendHour    = -1;
    int iTimeSendMinute  = -1;
    int iTimeSendSecond  = -1;

    char *pcFtpAddr = NULL;
    char *pcFileName= NULL;
    char *pcUserName= NULL;
    char *pcPassword= NULL;
    int  iPort  = -1;
    int  iUsage = -1;

    void* lpCmdBuf = NULL;
    int   iBufSize = 0;
    int  iCmd              = iniparser_getint(g_pIni, "SetFTPUploadConfig:cmd", -1);
    switch(iCmd)
    {
    case 0:
        iSnapShotChannel  = iniparser_getint(g_pIni, "SetFTPUploadConfig:snapshotchannel", -1);
        iSnapShotEnable   = iniparser_getint(g_pIni, "SetFTPUploadConfig:snapshotenable", -1);
        iSnapShotInterval = iniparser_getint(g_pIni, "SetFTPUploadConfig:snapshotinterval", -1);
        iSnapShotQValue   = iniparser_getint(g_pIni, "SetFTPUploadConfig:snapshotqvalue", -1);
        snapshot.iChannel = iSnapShotChannel;
        snapshot.iEnable  = iSnapShotEnable;
        snapshot.iInterval= iSnapShotInterval;
        snapshot.iQValue  = iSnapShotQValue;
        lpCmdBuf = &snapshot;
        iBufSize = sizeof(FTP_SNAPSHOT);
        break;
    case 1:
        iLinkSendChannel  = iniparser_getint(g_pIni, "SetFTPUploadConfig:linksendchannel", -1);
        iLinkSendEnable   = iniparser_getint(g_pIni, "SetFTPUploadConfig:linksendenable", -1);
        iLinkSendMethod   = iniparser_getint(g_pIni, "SetFTPUploadConfig:linksendmethod", -1);
        linkSend.iChannel = iLinkSendChannel;
        linkSend.iEnable  = iLinkSendEnable;
        linkSend.iMethod  = iLinkSendMethod;
        lpCmdBuf = &linkSend;
        iBufSize = sizeof(FTP_LINKSEND);
        break;
    case 2:
        iTimeSendChannel  = iniparser_getint(g_pIni, "SetFTPUploadConfig:timesendchannel", -1);
        iTimeSendEnable   = iniparser_getint(g_pIni, "SetFTPUploadConfig:timesendenable", -1);
        iTimeSendFileType = iniparser_getint(g_pIni, "SetFTPUploadConfig:timesendfiletype", -1);
        iTimeSendHour     = iniparser_getint(g_pIni, "SetFTPUploadConfig:timesendhour", -1);
        iTimeSendMinute   = iniparser_getint(g_pIni, "SetFTPUploadConfig:timesendminute", -1);
        iTimeSendSecond   = iniparser_getint(g_pIni, "SetFTPUploadConfig:timesendsecond", -1);
        timeSend.iChannel = iTimeSendChannel;
        timeSend.iEnable  = iTimeSendEnable;
        timeSend.iFileType= iTimeSendFileType;
        timeSend.iHour    = iTimeSendHour;
        timeSend.iMinute  = iTimeSendMinute;
        timeSend.iSecond  = iTimeSendSecond;
        lpCmdBuf = &timeSend;
        iBufSize = sizeof(FTP_TIMEDSEND);
        break;
    case 3:
        pcFtpAddr  = iniparser_getstring(g_pIni, "SetFTPUploadConfig:updateftpaddress", NULL);
        pcFileName = iniparser_getstring(g_pIni, "SetFTPUploadConfig:updateftpfilename", NULL);
        pcUserName = iniparser_getstring(g_pIni, "SetFTPUploadConfig:updateftpusername", NULL); 
        pcPassword = iniparser_getstring(g_pIni, "SetFTPUploadConfig:updateftppassword", NULL);
        iPort      = iniparser_getint(g_pIni, "SetFTPUploadConfig:updateport", -1);
        iUsage     = iniparser_getint(g_pIni, "SetFTPUploadConfig:updateusage", -1);
        strcpy(update.cFtpAddr, pcFtpAddr);
        strcpy(update.cFileName, pcFileName);
        strcpy(update.cUserName, pcUserName);
        strcpy(update.cPassword, pcPassword);
        update.iPort = iPort;
        update.iUsage= iUsage;
        lpCmdBuf = &update;
        iBufSize = sizeof(FTP_UPDATE);
        break;
    default:
        break;
    }

    NetClient_SetFTPUploadConfig(g_iLogonID, iCmd, lpCmdBuf, iBufSize);

    fprintf(stderr, "SetFTPUploadConfig Wait .................. \n");
    usleep(1000*1000);
    
    memset(&snapshot, 0 , sizeof(FTP_SNAPSHOT));
    memset(&linkSend, 0 , sizeof(FTP_LINKSEND));
    memset(&timeSend, 0 , sizeof(FTP_TIMEDSEND));
    memset(&update,   0 , sizeof(FTP_UPDATE));

    switch(iCmd)
    {
    case 0:
        lpCmdBuf = &snapshot; 
        iBufSize = sizeof(FTP_SNAPSHOT);
        break;
    case 1:
        lpCmdBuf = &linkSend; 
        iBufSize = sizeof(FTP_LINKSEND);
        break;
    case 2:
        lpCmdBuf = &timeSend; 
        iBufSize = sizeof(FTP_TIMEDSEND);
        break;
    case 3:
        lpCmdBuf = &update; 
        iBufSize = sizeof(FTP_UPDATE);
        break;
    default:
        break;
    }

    NetClient_GetFTPUploadConfig(g_iLogonID, iCmd + 4, lpCmdBuf, iBufSize);
    bool blSuccess = false;
    switch(iCmd)
    {
    case 0:
        if (iSnapShotChannel == snapshot.iChannel && iSnapShotEnable == snapshot.iEnable &&
            iSnapShotInterval == snapshot.iInterval && iSnapShotQValue == snapshot.iQValue)
        {
            blSuccess = true;
        }
        break;
    case 1:
        if (iLinkSendChannel == linkSend.iChannel && iLinkSendEnable == linkSend.iEnable && iLinkSendMethod == linkSend.iMethod)
        {
            blSuccess = true;
        }
        break;
    case 2:
        if (iTimeSendChannel == timeSend.iChannel && iTimeSendEnable == timeSend.iEnable &&
            iTimeSendFileType == timeSend.iFileType && iTimeSendHour == timeSend.iHour &&
            iTimeSendMinute == timeSend.iMinute && iTimeSendSecond == timeSend.iSecond)
        {
            blSuccess = true;
        }
        break;
    case 3:
        if (0 == strcmp(pcFtpAddr, update.cFtpAddr) && 0 == strcmp(pcFileName, update.cFileName) &&
            0 == strcmp(pcUserName, update.cUserName) && 0 == strcmp(pcPassword, update.cPassword) &&
            iPort == update.iPort && iUsage == update.iUsage)
        {
            blSuccess = true;
        }
        break;
    default:
        break;
    }
    if (blSuccess)
    {
        fprintf(stderr, "SetFTPUploadConfig GetFTPUploadConfig .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetFTPUploadConfig GetFTPUploadConfig .................. [FAIL]\n");
    }

}

void Auto_SetGetDigitalChannelConfig()
{
    int iChannel            = iniparser_getint(g_pIni, "SetDigitalChannelConfig:channel", -1);
    int iCmd                = iniparser_getint(g_pIni, "SetDigitalChannelConfig:cmd", 1);
    int iEnable             = iniparser_getint(g_pIni, "SetDigitalChannelConfig:enable", -1);
    int iConnectMode        = iniparser_getint(g_pIni, "SetDigitalChannelConfig:connectmode", -1);
    char *pcIP              = iniparser_getstring(g_pIni, "SetDigitalChannelConfig:ip", NULL);
    char *pcProxyIP         = iniparser_getstring(g_pIni, "SetDigitalChannelConfig:proxyip", NULL);  
    int iDevChannel         = iniparser_getint(g_pIni, "SetDigitalChannelConfig:devchannel", -1);
    int iDevPort            = iniparser_getint(g_pIni, "SetDigitalChannelConfig:devport", -1);
    int iStreamType         = iniparser_getint(g_pIni, "SetDigitalChannelConfig:streamtype", -1);
    int iNetMode            = iniparser_getint(g_pIni, "SetDigitalChannelConfig:netmode", -1);
    char *pcPtzProtocolName = iniparser_getstring(g_pIni, "SetDigitalChannelConfig:ptzprotocolname", NULL);  
    int iPtzAddr            = iniparser_getint(g_pIni, "SetDigitalChannelConfig:ptzaddr", -1);
    char *pcUserName        = iniparser_getstring(g_pIni, "SetDigitalChannelConfig:username", NULL);  
    char *pcPassword        = iniparser_getstring(g_pIni, "SetDigitalChannelConfig:password", NULL);  
    char *pcEncryptKey      = iniparser_getstring(g_pIni, "SetDigitalChannelConfig:encryptkey", NULL);  
	int iServerType			= iniparser_getint(g_pIni, "SetDigitalChannelConfig:servertype", -1);
    TDigitalChannelParam digitalChannelInfo = {0};
    digitalChannelInfo.iChannel = iChannel;
    digitalChannelInfo.iEnable  = iEnable;
    digitalChannelInfo.iConnectMode = iConnectMode;
    strcpy(digitalChannelInfo.cIP, pcIP);
    strcpy(digitalChannelInfo.cProxyIP, pcProxyIP);
    digitalChannelInfo.iDevChannel = iDevChannel;
    digitalChannelInfo.iDevPort    = iDevPort;
    digitalChannelInfo.iStreamType = iStreamType;
    digitalChannelInfo.iNetMode    = iNetMode;
    strcpy(digitalChannelInfo.cPtzProtocolName, pcPtzProtocolName);
    digitalChannelInfo.iPtzAddr    = iPtzAddr;
    strcpy(digitalChannelInfo.cUserName, pcUserName);
    strcpy(digitalChannelInfo.cPassword, pcPassword);
    strcpy(digitalChannelInfo.cEncryptKey, pcEncryptKey);
	digitalChannelInfo.iServerType = iServerType;

    NetClient_SetDigitalChannelConfig(g_iLogonID, iChannel, iCmd, &digitalChannelInfo, sizeof(TDigitalChannelParam));

    fprintf(stderr, "SetDigitalChannelConfig Wait .................. \n");
    usleep(1000*1000);

    memset(&digitalChannelInfo, 0, sizeof(TDigitalChannelParam));
    NetClient_GetDigitalChannelConfig(g_iLogonID, iChannel, iCmd, &digitalChannelInfo, sizeof(TDigitalChannelParam));

    if (digitalChannelInfo.iChannel == iChannel && digitalChannelInfo.iEnable == iEnable &&
        digitalChannelInfo.iConnectMode == iConnectMode && 0 ==  strcmp(digitalChannelInfo.cIP, pcIP) &&
        0 == strcmp(digitalChannelInfo.cProxyIP, pcProxyIP) && digitalChannelInfo.iDevChannel == iDevChannel &&
        digitalChannelInfo.iDevPort == iDevPort && digitalChannelInfo.iStreamType == iStreamType &&
        digitalChannelInfo.iNetMode == iNetMode && 0 == strcmp(digitalChannelInfo.cPtzProtocolName, pcPtzProtocolName) &&
        digitalChannelInfo.iPtzAddr == iPtzAddr && 0 == strcmp(digitalChannelInfo.cUserName, pcUserName) &&
        0 == strcpy(digitalChannelInfo.cPassword, pcPassword) && 0 == strcmp(digitalChannelInfo.cEncryptKey, pcEncryptKey) &&
		(digitalChannelInfo.iPtzAddr == iServerType))
    {
        fprintf(stderr, "SetDigitalChannelConfig GetDigitalChannelConfig .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetDigitalChannelConfig GetDigitalChannelConfig .................. [FAIL]\n");
    }
}

void Auto_DigitalChannelSend()
{
    int iChannel       = iniparser_getint(g_pIni, "DigitalChannelSend:channel", -1);
    char *pcInfomation = iniparser_getstring(g_pIni, "DigitalChannelSend:infomation", NULL);  
    int iRet = NetClient_DigitalChannelSend(g_iLogonID, iChannel, (unsigned char *)pcInfomation, strlen(pcInfomation));
    fprintf(stderr, "DigitalChannelSend Wait .................. \n");
    usleep(1000*1000);
    if(iRet != 0)
    {
        fprintf(stderr, "DigitalChannelSend .................. [FAIL]\n");
    }
    else
    {
        fprintf(stderr, "DigitalChannelSend .................. [OK]\n");
    }
}

void Auto_SetGetVideoNPModeEx()
{
    int iChannel = iniparser_getint(g_pIni, "SetVideoNPModeEx:channel", -1);
    int iNPMode = iniparser_getint(g_pIni, "SetVideoNPModeEx:mode", 0);
    VIDEO_NORM _iNPMode;
    if (iNPMode == 0)
    {
        _iNPMode = VIDEO_MODE_PAL; 
    }
    else if (iNPMode == 1)
    {
        _iNPMode = VIDEO_MODE_NTSC;
    }
    else
    {
        _iNPMode = VIDEO_MODE_AUTO;
    }
    NetClient_SetVideoNPModeEx(g_iLogonID, iChannel, _iNPMode);
    fprintf(stderr, "SetVideoNPModeEx Wait .................. \n");
    usleep(20000*1000);

    VIDEO_NORM NPMode;
    NetClient_GetVideoNPModeEx(g_iLogonID, iChannel, &NPMode);

    if(NPMode == _iNPMode)
    {
        fprintf(stderr, "SetVideoNPModeEx  GetVideoNPModeEx.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoNPModeEx  GetVideoNPModeEx.................. [FAIL]\n");
    }
}

void Auto_GetDigitalChannelNum()
{
    int iChannelCount = 0;
    int iRet = NetClient_GetDigitalChannelNum(g_iLogonID, &iChannelCount);
    fprintf(stderr, "GetDigitalChannelNum Wait .................. \n");
    usleep(1000*1000);
    if(iRet != 0)
    {
         fprintf(stderr, "GetDigitalChannelNum .................. [FAIL]\n");
    }
    else
    {
         fprintf(stderr, "GetDigitalChannelNum .................. [OK]\n");
    }
}

void Auto_GetChannelProperty()
{
    int iChannel     = iniparser_getint(g_pIni, "GetChannelProperty:channel", -1);
    int iCmd         = iniparser_getint(g_pIni, "GetChannelProperty:cmd", 1);
    int iChannelType = 0;
    int iBufferSize  = iniparser_getint(g_pIni, "GetChannelProperty:buffersize", 4);
    int iRet = NetClient_GetChannelProperty(g_iLogonID,iChannel, iCmd, (void*)(&iChannelType), iBufferSize);
    fprintf(stderr, "GetChannelProperty Wait .................. \n");
    usleep(1000*1000);
    if(iRet != 0)
    {
        fprintf(stderr, "GetChannelProperty .................. [FAIL]\n");
    }
    else
    {
        fprintf(stderr, "GetChannelProperty .................. [OK]\n");
    }
}

void Auto_SetGetDeviceTimerReboot()
{
    int iEnable   = iniparser_getint(g_pIni, "SetDeviceTimerReboot:enable", -1);
    int iInterval = iniparser_getint(g_pIni, "SetDeviceTimerReboot:interval", -1);
    int iHour     = iniparser_getint(g_pIni, "SetDeviceTimerReboot:hour", -1);

    NetClient_SetDeviceTimerReboot(g_iLogonID, iEnable, iInterval, iHour);

    int iEnable1   = 0;
    int iInterval1 = 0;
    int iHour1     = 0;

    fprintf(stderr, "SetDeviceTimerReboot Wait .................. \n");
    usleep(1000*1000);
    NetClient_GetDeviceTimerReboot(g_iLogonID, &iEnable1, &iInterval1, &iHour1);

    if(iEnable == iEnable1 && iInterval == iInterval1 && iHour == iHour1)
    {
        fprintf(stderr, "SetDeviceTimerReboot  GetDeviceTimerReboot.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetDeviceTimerReboot  GetDeviceTimerReboot.................. [FAIL]\n");
    }
}

void Auto_SetGetVideoCoverSchedule()
{
    int iChannel = iniparser_getint(g_pIni, "SetVideoCoverSchedule:channel", -1);
    int iWeekDay = iniparser_getint(g_pIni, "SetVideoCoverSchedule:weekday", -1);
    NVS_SCHEDTIME timeSeg1,timeSeg2,timeSeg3,timeSeg4;
    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    int iStartHour1  = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg1starthour", -1);
    int iStartMin1   = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg1startmin", -1);
    int iStopHour1   = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg1stophour", -1);
    int iStopMin1    = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg1stopmin", -1);
    int iRecordMode1 = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg1recordmode", -1);

    int iStartHour2  = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg2starthour", -1);
    int iStartMin2   = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg2startmin", -1);
    int iStopHour2   = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg2stophour", -1);
    int iStopMin2    = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg2stopmin", -1);
    int iRecordMode2 = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg2recordmode", -1);

    int iStartHour3  = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg3starthour", -1);
    int iStartMin3   = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg3startmin", -1);
    int iStopHour3   = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg3stophour", -1);
    int iStopMin3    = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg3stopmin", -1);
    int iRecordMode3 = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg3recordmode", -1);

    int iStartHour4  = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg4starthour", -1);
    int iStartMin4   = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg4startmin", -1);
    int iStopHour4   = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg4stophour", -1);
    int iStopMin4    = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg4stopmin", -1);
    int iRecordMode4 = iniparser_getint(g_pIni, "SetVideoCoverSchedule:timeseg4recordmode", -1);

    timeSeg1.iStartHour  = iStartHour1;
    timeSeg1.iStartMin   = iStartMin1;
    timeSeg1.iStopHour   = iStopHour1;
    timeSeg1.iStopMin    = iStopMin1;
    timeSeg1.iRecordMode = iRecordMode1;

    timeSeg2.iStartHour  = iStartHour2;
    timeSeg2.iStartMin   = iStartMin2;
    timeSeg2.iStopHour   = iStopHour2;
    timeSeg2.iStopMin    = iStopMin2;
    timeSeg2.iRecordMode = iRecordMode2;

    timeSeg3.iStartHour  = iStartHour3;
    timeSeg3.iStartMin   = iStartMin3;
    timeSeg3.iStopHour   = iStopHour3;
    timeSeg3.iStopMin    = iStopMin3;
    timeSeg3.iRecordMode = iRecordMode3;

    timeSeg4.iStartHour  = iStartHour4;
    timeSeg4.iStartMin   = iStartMin4;
    timeSeg4.iStopHour   = iStopHour4;
    timeSeg4.iStopMin    = iStopMin4;
    timeSeg4.iRecordMode = iRecordMode4;

    NVS_SCHEDTIME* schedule[] = {&timeSeg1,&timeSeg2,&timeSeg3,&timeSeg4};
    NetClient_SetVideoCoverSchedule(g_iLogonID, iChannel, iWeekDay, schedule);

    fprintf(stderr, "SetVideoCoverSchedule Wait .................. \n");
    usleep(1000*1000);

    memset(&timeSeg1,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg2,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg3,0,sizeof(NVS_SCHEDTIME));
    memset(&timeSeg4,0,sizeof(NVS_SCHEDTIME));

    NetClient_GetVideoCoverSchedule(g_iLogonID, iChannel, iWeekDay, schedule);
    
    if ( timeSeg1.iStartHour == iStartHour1 && timeSeg1.iStartMin == iStartMin1 &&
         timeSeg1.iStopHour  == iStopHour1  && timeSeg1.iStopMin  == iStopMin1 && timeSeg1.iRecordMode == iRecordMode1 && 
         timeSeg2.iStartHour == iStartHour2 && timeSeg2.iStartMin == iStartMin2 &&
         timeSeg2.iStopHour  == iStopHour2  && timeSeg2.iStopMin  == iStopMin2 && timeSeg1.iRecordMode == iRecordMode2 && 
         timeSeg3.iStartHour == iStartHour3 && timeSeg3.iStartMin == iStartMin3 &&
         timeSeg3.iStopHour  == iStopHour3  && timeSeg3.iStopMin  == iStopMin3 && timeSeg1.iRecordMode == iRecordMode3)
    {
        fprintf(stderr, "SetVideoCoverSchedule GetVideoCoverSchedule.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoCoverSchedule GetVideoCoverSchedule.................. [FAIL]\n");
    }
}

void Auto_SetGetCPUMEMAlarmThreshold()
{
    int iCPUThreshold = iniparser_getint(g_pIni, "SetCPUMEMAlarmThreshold:cputhreshold", -1);
    int iMEMThreshold = iniparser_getint(g_pIni, "SetCPUMEMAlarmThreshold:memthreshold", -1);
    NetClient_SetCPUMEMAlarmThreshold(g_iLogonID, iCPUThreshold, iMEMThreshold);
    fprintf(stderr, "SetCPUMEMAlarmThreshold Wait .................. \n");
    usleep(1000*1000);
    int iCPUThreshold1 = 0;
    int iMEMThreshold1  = 0;
    NetClient_GetCPUMEMAlarmThreshold(g_iLogonID, &iCPUThreshold, &iMEMThreshold);
    if(iCPUThreshold == iCPUThreshold1 && iMEMThreshold == iMEMThreshold1)
    {
        fprintf(stderr, "SetCPUMEMAlarmThreshold GetCPUMEMAlarmThreshold.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetCPUMEMAlarmThreshold GetCPUMEMAlarmThreshold.................. [FAIL]\n");
    }
}

void Auto_SetGetDZInfo()
{
    char *pcParam1  = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo1", NULL);  
    char *pcParam2  = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo2", NULL); 
    char *pcParam3  = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo3", NULL); 
    char *pcParam4  = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo4", NULL); 
    char *pcParam5  = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo5", NULL); 
    char *pcParam6  = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo6", NULL);  
    char *pcParam7  = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo7", NULL); 
    char *pcParam8  = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo8", NULL); 
    char *pcParam9  = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo9", NULL); 
    char *pcParam10 = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo10", NULL); 
    char *pcParam11 = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo11", NULL);  
    char *pcParam12 = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo12", NULL); 
    char *pcParam13 = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo13", NULL); 
    char *pcParam14 = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo14", NULL); 
    char *pcParam15 = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo15", NULL); 
    char *pcParam16 = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo16", NULL);  
    char *pcParam17 = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo17", NULL); 
    char *pcParam18 = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo18", NULL); 
    char *pcParam19 = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo19", NULL); 
    char *pcParam20 = iniparser_getstring(g_pIni, "SetDZInfo:dzinfo20", NULL); 
    DZ_INFO_PARAM dzinfo = {{0}};
    strcpy(dzinfo.m_cParam1, pcParam1);
    strcpy(dzinfo.m_cParam2, pcParam2);
    strcpy(dzinfo.m_cParam3, pcParam3);
    strcpy(dzinfo.m_cParam4, pcParam4);
    strcpy(dzinfo.m_cParam5, pcParam5);
    strcpy(dzinfo.m_cParam6, pcParam6);
    strcpy(dzinfo.m_cParam7, pcParam7);
    strcpy(dzinfo.m_cParam8, pcParam8);
    strcpy(dzinfo.m_cParam9, pcParam9);
    strcpy(dzinfo.m_cParam10, pcParam10);
    strcpy(dzinfo.m_cParam11, pcParam11);
    strcpy(dzinfo.m_cParam12, pcParam12);
    strcpy(dzinfo.m_cParam13, pcParam13);
    strcpy(dzinfo.m_cParam14, pcParam14);
    strcpy(dzinfo.m_cParam15, pcParam15);
    strcpy(dzinfo.m_cParam16, pcParam16);
    strcpy(dzinfo.m_cParam17, pcParam17);
    strcpy(dzinfo.m_cParam18, pcParam18);
    strcpy(dzinfo.m_cParam19, pcParam19);
    strcpy(dzinfo.m_cParam20, pcParam20);

    NetClient_SetDZInfo(g_iLogonID, &dzinfo);
    fprintf(stderr, "SetDZInfo Wait .................. \n");
    usleep(1000*1000);

    memset(&dzinfo, 0, sizeof(DZ_INFO_PARAM));
    NetClient_GetDZInfo(g_iLogonID, &dzinfo);

    if(0 == strcmp(dzinfo.m_cParam1, pcParam1) &&
        0 == strcmp(dzinfo.m_cParam2, pcParam2) &&
        0 == strcmp(dzinfo.m_cParam3, pcParam3) &&
        0 == strcmp(dzinfo.m_cParam4, pcParam4) &&
        0 == strcmp(dzinfo.m_cParam5, pcParam5) &&
        0 == strcmp(dzinfo.m_cParam6, pcParam6) &&
        0 == strcmp(dzinfo.m_cParam7, pcParam7) &&
        0 == strcmp(dzinfo.m_cParam8, pcParam8) &&
        0 == strcmp(dzinfo.m_cParam9, pcParam9) &&
        0 == strcmp(dzinfo.m_cParam10, pcParam10) &&
        0 == strcmp(dzinfo.m_cParam11, pcParam11) &&
        0 == strcmp(dzinfo.m_cParam12, pcParam12) &&
        0 == strcmp(dzinfo.m_cParam13, pcParam13) &&
        0 == strcmp(dzinfo.m_cParam14, pcParam14) &&
        0 == strcmp(dzinfo.m_cParam15, pcParam15) &&
        0 == strcmp(dzinfo.m_cParam16, pcParam16) &&
        0 == strcmp(dzinfo.m_cParam17, pcParam17) &&
        0 == strcmp(dzinfo.m_cParam18, pcParam18) &&
        0 == strcmp(dzinfo.m_cParam19, pcParam19) &&
        0 == strcmp(dzinfo.m_cParam20, pcParam20))
    {
        fprintf(stderr, "SetDZInfo GetDZInfo.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetDZInfo GetDZInfo.................. [FAIL]\n");
    }
}

void Auto_SetGetPTZAutoBack()
{
    int iChannel     = iniparser_getint(g_pIni, "SetPTZAutoBack:channel", -1);
    int iEnable      = iniparser_getint(g_pIni, "SetPTZAutoBack:enable", -1);
    int iPresetIndex = iniparser_getint(g_pIni, "SetPTZAutoBack:presetindex", -1);
    int iIdleTime    = iniparser_getint(g_pIni, "SetPTZAutoBack:idletime", -1);
    NetClient_SetPTZAutoBack(g_iLogonID, iChannel, iEnable, iPresetIndex, iIdleTime);
    fprintf(stderr, "SetPTZAutoBack Wait .................. \n");
    usleep(1000*1000);

    int iEnable1 = 0;
    int iPresetIndex1 = 0;
    int iIdleTime1 = 0;

    NetClient_GetPTZAutoBack(g_iLogonID, iChannel, &iEnable1, &iPresetIndex1, &iIdleTime1);

    if( iEnable == iEnable1 && iPresetIndex == iPresetIndex1 && iIdleTime == iIdleTime1)
    {
        fprintf(stderr, "SetPTZAutoBack GetPTZAutoBack.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetPTZAutoBack GetPTZAutoBack.................. [FAIL]\n");
    }
}

void Auto_SetGet3GVPND()
{
    char *pcDialNumber = iniparser_getstring(g_pIni, "Set3GVPND:dialnumber", NULL);
    char *pcAccount    = iniparser_getstring(g_pIni, "Set3GVPND:account", NULL);
    char *pcPassword   = iniparser_getstring(g_pIni, "Set3GVPND:password", NULL);
    NetClient_Set3GVPND(g_iLogonID, pcDialNumber, pcAccount, pcPassword);
    fprintf(stderr, "Set3GVPND Wait .................. \n");
    usleep(1000*1000);
    char cDialNumber[256] = {0};
    char cAccount[256] = {0};
    char cPassword[256] = {0};
    NetClient_Get3GVPND(g_iLogonID, cDialNumber, cAccount, cPassword);

    if (0 == strcmp(pcDialNumber, cDialNumber) && 0 == strcmp(pcAccount, cAccount) && 0 == strcmp(pcPassword, cPassword))
    {
        fprintf(stderr, "Set3GVPND Get3GVPND.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "Set3GVPND Get3GVPND.................. [FAIL]\n");
    }

}

void Auto_SetGetHDCamerEx()
{
    RECT rect = {0};
    int iBuf = 0;
    void *pBuff = NULL;
    int iBufferSize = 0;
    int iChannel = iniparser_getint(g_pIni, "SetHDCamerEx:channel", -1);
    int iFuncID  = iniparser_getint(g_pIni, "SetHDCamerEx:funid", -1);
    if(6 == iFuncID || 7 == iFuncID)
    {
       rect.left   = iniparser_getint(g_pIni, "SetHDCamerEx:rectleft", -1);
       rect.top    = iniparser_getint(g_pIni, "SetHDCamerEx:recttop", -1);
       rect.right  = iniparser_getint(g_pIni, "SetHDCamerEx:rectright", -1);
       rect.bottom = iniparser_getint(g_pIni, "SetHDCamerEx:rectbottom", -1);
       pBuff = &rect;
       iBufferSize = sizeof(rect);
    }
    else
    {
        iBuf = iniparser_getint(g_pIni, "SetHDCamerEx:intbuffer", -1);
        pBuff = &iBuf;
        iBufferSize = sizeof(int);
    }
    NetClient_SetHDCamerEx(g_iLogonID, iChannel, iFuncID, pBuff, iBufferSize);

    fprintf(stderr, "SetHDCamerEx Wait .................. \n");
    usleep(1000*1000);

    RECT rect1 = {0};
    int  iPara = iniparser_getint(g_pIni, "SetHDCamerEx:intpara", -1);
    void *pPara = NULL;
    int iSize;
    if(6 == iFuncID || 7 == iFuncID)
    {
        pPara = &rect1;
        iSize = sizeof(RECT);
    }
    else
    {
        pPara = &iPara;
        iSize = sizeof(int);
    }
    NetClient_GetHDCamerEx(g_iLogonID, iChannel, iFuncID, pPara, iSize);
    bool blSuccess = false;
    if(6 == iFuncID || 7 == iFuncID)
    {
        if(rect.left == rect1.left && rect.top == rect1.top &&
           rect.right == rect1.right && rect.bottom == rect1.bottom)
        {
            blSuccess = true;
        }
    }
    else
    {
        if(iPara == iBuf)
        {
            blSuccess = true;
        }
    }
    if(blSuccess)
    {
        fprintf(stderr, "SetHDCamerEx GetHDCamerEx.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetHDCamerEx GetHDCamerEx.................. [FAIL]\n");
    }
}

void Auto_SetGetPort()
{
   
}

void Auto_GetMaxVideoSize()
{
    int iVideoSize = 0;
    int iRet = NetClient_GetMaxVideoSize(g_iLogonID, &iVideoSize);
    fprintf(stderr, "GetMaxVideoSize Wait .................. \n");
    usleep(1000*1000);
    if(iRet < 0)
    {
        fprintf(stderr, "GetMaxVideoSize.................. [FAIL]\n");
    }
    else
    {
        fprintf(stderr, "GetMaxVideoSize.................. [OK]\n");
    }
}

void Auto_SetGetBitRatePercent()
{
    int iChannel = iniparser_getint(g_pIni, "SetBitRatePercent:channel", -1);
    int iPercent = iniparser_getint(g_pIni, "SetBitRatePercent:percent", -1);
    NetClient_SetBitRatePercent(g_iLogonID, iChannel, iPercent);
    fprintf(stderr, "SetBitRatePercent Wait .................. \n");
    usleep(1000*1000);
    int iPercent1 = 0;
    NetClient_GetBitRatePercent(g_iLogonID, iChannel, &iPercent1);
    if(iPercent == iPercent1)
    {
        fprintf(stderr, "SetBitRatePercent GetBitRatePercent.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetBitRatePercent GetBitRatePercent.................. [FAIL]\n");
    }
}

void Auto_SetGetFTPUsage()
{
    char *pcFtpAddr  = iniparser_getstring(g_pIni, "SetFTPUsage:ftpaddr", NULL);
    int  iPort       = iniparser_getint(g_pIni, "SetFTPUsage:port", -1);
    char *pcFileName = iniparser_getstring(g_pIni, "SetFTPUsage:filename", NULL);
    char *pcUserName = iniparser_getstring(g_pIni, "SetFTPUsage:username", NULL);
    char *pcPassword = iniparser_getstring(g_pIni, "SetFTPUsage:password", NULL);
    int  iUsage      = iniparser_getint(g_pIni, "SetFTPUsage:usage", -1);
    FTP_UPDATE ftpUpdate;
    memset(&ftpUpdate, 0, sizeof(ftpUpdate));
    strcpy(ftpUpdate.cFtpAddr, pcFtpAddr);
    ftpUpdate.iPort = iPort;
    strcpy(ftpUpdate.cFileName, pcFileName);
    strcpy(ftpUpdate.cUserName, pcUserName);
    strcpy(ftpUpdate.cPassword, pcPassword);
    ftpUpdate.iUsage = iUsage;
    NetClient_SetFTPUsage(g_iLogonID, ftpUpdate.cFtpAddr, ftpUpdate.iPort, ftpUpdate.cFileName, ftpUpdate.cUserName, ftpUpdate.cPassword, ftpUpdate.iUsage);
    fprintf(stderr, "SetFTPUsage Wait .................. \n");
    usleep(1000*1000);
    memset(&ftpUpdate, 0, sizeof(ftpUpdate));
    NetClient_GetFTPUsage(g_iLogonID, ftpUpdate.cFtpAddr, &ftpUpdate.iPort, ftpUpdate.cFileName,
                                      ftpUpdate.cUserName, ftpUpdate.cPassword, &ftpUpdate.iUsage);
    if (0 == strcmp(ftpUpdate.cFtpAddr, pcFtpAddr) && iPort == ftpUpdate.iPort && 0 == strcmp(ftpUpdate.cFileName, pcFileName) &&
        0 == strcmp(ftpUpdate.cUserName, pcUserName) && 0 == strcpy(ftpUpdate.cPassword, pcPassword) && ftpUpdate.iUsage == iUsage)
    {
        fprintf(stderr, "SetFTPUsage GetFTPUsage.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetFTPUsage GetFTPUsage.................. [FAIL]\n");
    }
}

void Auto_GetVideoParam()
{
    int iChannel = iniparser_getint(g_pIni, "GetVideoParam:channel", -1);
    int iWidth = 0;
    int iHeight = 0;
    int iFrameRate = 0;

    int iRet = NetClient_GetVideoParam(g_uiRecv[iChannel], &iWidth, &iHeight, &iFrameRate);
    fprintf(stderr, "GetVideoParam Wait .................. \n");
    usleep(1000*1000);
    if(iRet < 0)
    {
        fprintf(stderr, "GetVideoParam.................. [FAIL]\n");
    }
    else
    {
        fprintf(stderr, "GetVideoParam.................. [OK]\n");
    }
}

void Auto_SetGetOSDAlpha()
{
    int iChannel = iniparser_getint(g_pIni, "SetOSDAlpha:channel", -1); 
    int iAlpha   = iniparser_getint(g_pIni, "SetOSDAlpha:alpha", -1);
    NetClient_SetOSDAlpha(g_iLogonID, iChannel, iAlpha);  
    fprintf(stderr, "SetOSDAlpha Wait .................. \n");
    usleep(1000*1000);
    int iAlpha1 = 0;
    NetClient_GetOSDAlpha(g_iLogonID, iChannel, &iAlpha1);
    if(iAlpha == iAlpha1)
    {
        fprintf(stderr, "SetOSDAlpha GetOSDAlpha.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetOSDAlpha GetOSDAlpha.................. [FAIL]\n");
    }
}

void Auto_DeviceSetup()
{
    
}

void Auto_SetGetChannelSipConfig()
{
    int iNum = iniparser_getint(g_pIni, "SetChannelSipConfig:num", -1); 
    if(1 == iNum)
    {
        TSipVideoChannel svc = {0};
        int iChannelNo    = iniparser_getint(g_pIni, "SetChannelSipConfig:channelno", -1); 
        char* pcChannelID = iniparser_getstring(g_pIni, "SetChannelSipConfig:channelid", NULL);
        int iLevel        = iniparser_getint(g_pIni, "SetChannelSipConfig:level", -1);
        int iPtzTime      = iniparser_getint(g_pIni, "SetChannelSipConfig:ptztime", -1);  
        svc.iChannelNo = iChannelNo;
        strcpy(svc.cChannelID, pcChannelID);
        svc.iLevel = iLevel;
        svc.iPtzTime = iPtzTime;
        NetClient_SetChannelSipConfig(g_iLogonID, iChannelNo, SIP_CMD_SET_VIDEOCHANNEL, &svc, sizeof(svc));
        fprintf(stderr, "SetChannelSipConfig Wait .................. \n");
        usleep(1000*1000);
        memset(&svc, 0, sizeof(TSipVideoChannel));
        NetClient_GetChannelSipConfig(g_iLogonID, iChannelNo, SIP_CMD_GET_VIDEOCHANNEL, &svc, sizeof(svc));
        if(iChannelNo == svc.iChannelNo && 0 == strcmp(pcChannelID,svc.cChannelID) && iLevel == svc.iLevel && iPtzTime == svc.iPtzTime)
        {
            fprintf(stderr, "SetChannelSipConfig GetChannelSipConfig.................. [OK]\n");
        }
        else
        {
            fprintf(stderr, "SetChannelSipConfig GetChannelSipConfig.................. [FAIL]\n");
        }
    }
    else if(2 == iNum)
    {
        TSipAlarmChannel sac = {0};
        int iChannelNo    = iniparser_getint(g_pIni, "SetChannelSipConfig:channelno", -1); 
        char* pcChannelID = iniparser_getstring(g_pIni, "SetChannelSipConfig:channelid", NULL);
        int iLevel        = iniparser_getint(g_pIni, "SetChannelSipConfig:level", -1);
        sac.iChannelNo = iChannelNo;
        strcpy(sac.cChannelID, pcChannelID);
        sac.iLevel = iLevel;
        NetClient_SetChannelSipConfig(g_iLogonID, iChannelNo, SIP_CMD_SET_ALARMCHANNEL, &sac, sizeof(sac));
        fprintf(stderr, "SetChannelSipConfig Wait .................. \n");
        usleep(1000*1000);
        if(iChannelNo == sac.iChannelNo && 0 == strcmp(pcChannelID,sac.cChannelID) && iLevel == sac.iLevel)
        {
            fprintf(stderr, "SetChannelSipConfig GetChannelSipConfig.................. [OK]\n");
        }
        else
        {
            fprintf(stderr, "SetChannelSipConfig GetChannelSipConfig.................. [FAIL]\n");
        }
    }
}

void Auto_SetGet3GConfig()
{
    int iCmd     = iniparser_getint(g_pIni, "Set3GConfig:cmd", -1); 
    int iChanNo  = iniparser_getint(g_pIni, "Set3GConfig:channelno", -1); 
    int iTimeOn  = iniparser_getint(g_pIni, "Set3GConfig:powerdelaytimeon", -1); 
    int iTimeOff = iniparser_getint(g_pIni, "Set3GConfig:powerdelaytimeoff", -1);  
    int iEnable  = iniparser_getint(g_pIni, "Set3GConfig:gpsoverlayenable", -1);  
    int iFilter  = iniparser_getint(g_pIni, "Set3GConfig:gpsfilter", -1); 
    int iMode    = iniparser_getint(g_pIni, "Set3GConfig:ftpuploadmode", -1); 
    TDVR3GInfo info = {0};
    TDVR3GInfoEx infoEx;
    memset(&infoEx, 0, sizeof(infoEx));
    bool blSuccess = false;
    switch(iCmd)
    {
    case 0:
        info.iPowerDelayOnTime = iTimeOn;
        info.iPowerDelayOffTime = iTimeOff;
        NetClient_Set3GConfig(g_iLogonID, DVR3G_CMD_SET_POWERDELAY, iChanNo, &info, sizeof(TDVR3GInfo));
        fprintf(stderr, "Set3GConfig Wait .................. \n");
        usleep(1000*1000);
        memset(&info, 0, sizeof(TDVR3GInfo));
        NetClient_Get3GConfig(g_iLogonID, DVR3G_CMD_GET_GPSOVERLAY, iChanNo, &info, sizeof(TDVR3GInfo));
        if(iTimeOn == info.iPowerDelayOnTime && iTimeOff == info.iPowerDelayOffTime)
        {
            blSuccess = true;
        }
        break;
    case 1:
        info.iGpsOverlay[iChanNo] = iEnable;
        NetClient_Set3GConfig(g_iLogonID, DVR3G_CMD_SET_GPSOVERLAY, iChanNo, &info, sizeof(TDVR3GInfo));
        fprintf(stderr, "Set3GConfig Wait .................. \n");
        usleep(1000*1000);
        memset(&info, 0, sizeof(TDVR3GInfo));
        NetClient_Get3GConfig(g_iLogonID, DVR3G_CMD_GET_GPSOVERLAY, iChanNo, &info, sizeof(TDVR3GInfo));
        if(iEnable == info.iGpsOverlay[iChanNo])
        {
            blSuccess = true;
        }
        break;
    case 2:
        info.iGpsFilter = iFilter;
        NetClient_Set3GConfig(g_iLogonID, DVR3G_CMD_SET_GPSFILTER, iChanNo, &info, sizeof(TDVR3GInfo));
        fprintf(stderr, "Set3GConfig Wait .................. \n");
        usleep(1000*1000);
        memset(&info, 0, sizeof(TDVR3GInfo));
        NetClient_Get3GConfig(g_iLogonID, DVR3G_CMD_GET_GPSFILTER, iChanNo,  &info, sizeof(TDVR3GInfo));
        if(iFilter == info.iGpsFilter)
        {
            blSuccess = true;
        }
        break;
    case 3:
        infoEx.iFtpUploadMode = iMode;
        NetClient_Set3GConfig(g_iLogonID, DVR3G_CMD_SET_FTPUPLOAD_MODE, iChanNo, &infoEx, sizeof(TDVR3GInfoEx));
        fprintf(stderr, "Set3GConfig Wait .................. \n");
        usleep(1000*1000);
        memset(&infoEx, 0, sizeof(infoEx));
        NetClient_Get3GConfig(g_iLogonID, DVR3G_CMD_GET_FTPUPLOAD_MODE, iChanNo, &infoEx, sizeof(TDVR3GInfoEx));
        if(iMode == infoEx.iFtpUploadMode)
        {
            blSuccess = true;
        }
        break;
    case 4:
        fprintf(stderr, "Set3GConfig Wait .................. \n");
        usleep(1000*1000);
        if(0 == NetClient_Get3GConfig(g_iLogonID, DVR3G_CMD_GET_SIMNUM, iChanNo, &info, sizeof(TDVR3GInfo)))
        {
            blSuccess = false;
        }
        break;
    default:
        break;
    }
    if(blSuccess)
    {
        fprintf(stderr, "Set3GConfig Get3GConfig.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "Set3GConfig Get3GConfig.................. [FAIL]\n");
    }
}

void Auto_SetGetVideoCombine()
{
    int iPicNum       = iniparser_getint(g_pIni, "SetVideoCombine:picnum", -1); 
    int iLayMode      = iniparser_getint(g_pIni, "SetVideoCombine:laymode", -1); 
    char *pcChannelID = iniparser_getstring(g_pIni, "SetVideoCombine:channelid", NULL);
    TVideoCombine vc;
    vc.iPicNum = iPicNum;
    vc.iRec = iLayMode;
    strcpy(vc.cChannelID, pcChannelID);
    NetClient_SetVideoCombine(g_iLogonID, &vc, sizeof(vc));
    fprintf(stderr, "SetVideoCombine Wait .................. \n");
    usleep(1000*1000);
    memset(&vc, 0, sizeof(TVideoCombine));
    NetClient_GetVideoCombine(g_iLogonID, &vc, sizeof(vc));
    if(iPicNum == vc.iPicNum && iLayMode == vc.iRec && strcmp(pcChannelID, vc.cChannelID))
    {
        fprintf(stderr, "SetVideoCombine GetVideoCombine.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetVideoCombine GetVideoCombine.................. [FAIL]\n");
    }
}

void Auto_SetGetCDBurnConfig()
{
    int iCmd  = iniparser_getint(g_pIni, "SetGetCDBurnConfig:cmd", -1); 
    TCDBurnPolicy pol = {0};
    int iRet = -1;
    int iCount = 0;
    iRet = NetClient_GetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_GET_CDROMCOUNT, &iCount, sizeof(int));
    if(iRet >= 0)
    {
        fprintf(stderr, "CDRomCount: %d\n", iCount);
    }
    else
    {
        fprintf(stderr, "Get CDRom count failed!\n");
        return;
    }
    int iID = iniparser_getint(g_pIni, "SetGetCDBurnConfig:id", -1); 
    TCDBurnStatus tBs = {0};
    int iList = 0;
    iCount = 0;
    switch(iCmd)
    {
    case 1:
        {
            iRet = NetClient_SetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_SET_START, &iID, sizeof(int)); 
            break;
        }
    case 2:
        {
            iRet = NetClient_SetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_SET_STOP, &iID, sizeof(int)); 
            break;
        }
    case 3:
        {
            int iMode = iniparser_getint(g_pIni, "SetGetCDBurnConfig:mode", -1);
            int iDeviceBits  = iniparser_getint(g_pIni, "SetGetCDBurnConfig:devicebit", -1);
            int iChannelBits = iniparser_getint(g_pIni, "SetGetCDBurnConfig:channelbit", -1);
            if(pol.iMode == 0)
            {
                pol.iCDRomID = iID;
                if(pol.iCDRomID < 0)
                {
                    return;
                }
                
                int iTemp = 1 << pol.iCDRomID;
                if(iTemp != iDeviceBits)
                {
                    fprintf(stderr, "DeviceBits is invalid!\n");
                    iDeviceBits = iTemp;
                }
            }
            pol.iDeviceBits[0] = iDeviceBits;
            pol.iChannelBits[0] = iChannelBits;
            NetClient_SetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_SET_MODE, &pol, sizeof(TCDBurnPolicy));
            fprintf(stderr, "SetGetCDBurnConfig Wait .................. \n");
            usleep(1000*1000);
            memset(&pol, 0, sizeof(TCDBurnStatus));
            NetClient_GetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_GET_MODE, &pol, sizeof(TCDBurnPolicy));
            if(iMode == pol.iMode && iDeviceBits == pol.iDeviceBits[0] && iChannelBits == pol.iChannelBits[0])
            {
                fprintf(stderr, "SetCDBurnConfig GetCDBurnConfig.................. [OK]\n");
            }
            else
            {
                fprintf(stderr, "SetCDBurnConfig GetCDBurnConfig.................. [FAIL]\n");
            }
            break;
        }
    case 4:
        iRet = NetClient_GetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_GET_CDROMLIST, &iList, sizeof(int));
        if(iRet >= 0)
        {
           fprintf(stderr, "SetCDBurnConfig GetCDBurnConfig.................. [OK]\n");
        }
        break;
    case 5:
        iRet = NetClient_GetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_GET_CDROMCOUNT, &iCount, sizeof(int));
        if(iRet >= 0)
        {
           fprintf(stderr, "SetCDBurnConfig GetCDBurnConfig.................. [OK]\n");
        }
        break;
    case 6:
        
        tBs.iCDRomID = iID;
        iRet = NetClient_GetCDBurnConfig(g_iLogonID, -1, CDBURN_CMD_GET_STATUS, &tBs, sizeof(TCDBurnStatus));
        if(iRet >= 0)
        {
            fprintf(stderr, "SetCDBurnConfig GetCDBurnConfig.................. [OK]\n");
        }
        break;
    default:
        break;
    }
}

void Auto_SetGetPreRecEnable()
{
    int iChan   = iniparser_getint(g_pIni, "SetPreRecEnable:channel", -1);
    int iEnable = iniparser_getint(g_pIni, "SetPreRecEnable:enable", -1);
    NetClient_SetPreRecEnable(g_iLogonID, iChan, iEnable);
    fprintf(stderr, "SetPreRecEnable Wait .................. \n");
    usleep(1000*1000);
    int iEnable1 = -1;
    NetClient_GetPreRecEnable(g_iLogonID, iChan, &iEnable1);
    if(iEnable1 == iEnable)
    {
        fprintf(stderr, "SetPreRecEnable GetPreRecEnable.................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetPreRecEnable GetPreRecEnable.................. [FAIL]\n");
    }
}
void Auto_VCASetGetConfig()
{
    vca_TVCAParam vcaParam = {0};
    int iCmd = iniparser_getint(g_pIni, "VCASetConfig:cmd", 0);
    switch(iCmd)
    {
    case 0:  //channel enable 
        {
            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            int iIniEnable = iniparser_getint(g_pIni, "VCASetConfig:channel_enable", 0);
            NetClient_VCASetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_SET_CHANNEL, &vcaParam, sizeof(vca_TVCAParam));
            fprintf(stderr, "NetClient_VCASetConfig Wait .................. \n");
            usleep(1000*1000);

            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            NetClient_VCAGetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_GET_CHANNEL, &vcaParam, sizeof(vca_TVCAParam));
            int iEnable = vcaParam.iEnable;

            if(iEnable == iIniEnable)
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->ChannelEnable.................. [OK]\n");
            else
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->ChannelEnable .................. [FAILED]\n");

            break;
        }
    case 1:		//video size
        {
            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            int iIniVideoSize = iniparser_getint(g_pIni, "VCASetConfig:vca_videoSize", 0);
            vcaParam.chnParam[g_iIniChannel].config.iVideoSize = iIniVideoSize;
            NetClient_VCASetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_SET_VIDEOSIZE, &vcaParam, sizeof(vca_TVCAParam));
            fprintf(stderr, "NetClient_VCASetConfig Wait .................. \n");
            NetClient_VCARestart(g_iLogonID);
            usleep(3000*1000);

            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            NetClient_VCAGetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_GET_VIDEOSIZE, &vcaParam, sizeof(vca_TVCAParam));
            int iVideoSize = vcaParam.chnParam[g_iIniChannel].config.iVideoSize;

            if(iVideoSize == iIniVideoSize)
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->ChannelEnable.................. [OK]\n");
            else
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->ChannelEnable .................. [FAILED]\n");

            break;
        }
    case 2:		//adv params
        {
            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            int iIniAdvEnable = iniparser_getint(g_pIni, "VCASetConfig:advparam_enable", 0);
            int iIniSensitivity = iniparser_getint(g_pIni, "VCASetConfig:sensitivity", 0);
            int iIniMinsize = iniparser_getint(g_pIni, "VCASetConfig:target_minsize", 0);
            int iIniMaxsize = iniparser_getint(g_pIni, "VCASetConfig:target_maxsize", 0);
            int iIniMinspeed = iniparser_getint(g_pIni, "VCASetConfig:target_minspeed", 0);
            int iIniMaxspeed = iniparser_getint(g_pIni, "VCASetConfig:target_maxspeed", 0);
            int iIniMaxwidth = iniparser_getint(g_pIni, "VCASetConfig:maxwidth", 0);
            int iIniMinwidth = iniparser_getint(g_pIni, "VCASetConfig:minwidth", 0);
            int iIniMaxheight = iniparser_getint(g_pIni, "VCASetConfig:maxheight", 0);
            int iIniMinheight = iniparser_getint(g_pIni, "VCASetConfig:minheight", 0);
            int iIniMinWHRatio = iniparser_getint(g_pIni, "VCASetConfig:minWHRatio", 0);
            int iIniMaxWHRatio = iniparser_getint(g_pIni, "VCASetConfig:maxWHRatio", 0);

            vca_TAdvParam &para = vcaParam.chnParam[g_iIniChannel].advParam;
            para.iEnable = iIniAdvEnable;
            para.iSensitivity = iIniSensitivity;
            para.iTargetMaxSize = iIniMaxsize;
            para.iTargetMinSize = iIniMinsize;
            para.iTargetMaxSpeed = iIniMaxspeed;
            para.iTargetMinSpeed = iIniMinspeed;
            para.iTargetMaxWidth = iIniMaxwidth;
            para.iTargetMinWidth = iIniMinwidth;
            para.iTargetMaxHeight = iIniMaxheight;
            para.iTargetMinHeight = iIniMinheight;
            para.iTargetMaxWHRatio = iIniMaxWHRatio;
            para.iTargetMinWHRatio = iIniMinWHRatio;

            NetClient_VCASetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_SET_ADVANCE_PARAM, &vcaParam, sizeof(vca_TVCAParam));
            fprintf(stderr, "NetClient_VCASetConfig Wait .................. \n");
            NetClient_VCARestart(g_iLogonID);
            usleep(3000*1000);

            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            NetClient_VCAGetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_GET_ADVANCE_PARAM, &vcaParam, sizeof(vca_TVCAParam));
            int iAdvEnable = para.iEnable;
            int iSensitivity = para.iSensitivity;
            int iMinsize = para.iTargetMinSize;
            int iMaxsize = para.iTargetMinSize;
            int iMinspeed = para.iTargetMinSpeed;
            int iMaxspeed = para.iTargetMaxSpeed;
            int iMaxwidth = para.iTargetMaxWidth;
            int iMinwidth = para.iTargetMinWidth;
            int iMaxheight = para.iTargetMaxHeight;
            int iMinheight = para.iTargetMinHeight;
            int iMinWHRatio = para.iTargetMaxWHRatio;
            int iMaxWHRatio = para.iTargetMinWHRatio;

            if(iAdvEnable == iIniAdvEnable &&
               iSensitivity == iIniSensitivity &&
               iMinsize == iIniMinsize &&
               iMaxsize == iIniMaxsize &&
               iMinspeed == iIniMinspeed &&
               iMaxspeed == iIniMaxspeed &&
               iMaxwidth == iIniMaxwidth &&
               iMinwidth == iIniMinwidth &&
               iMaxheight == iIniMaxheight &&
               iMinheight == iIniMinheight &&
               iMinWHRatio == iIniMinWHRatio &&
               iMaxWHRatio == iIniMaxWHRatio)
            {
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->Advance param.................. [OK]\n");
            }
            else
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->Advance param.................. [FAILED]\n");

            break;
        }
    case 3:		//target param
        {
            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            int iIniDisplayTarget = iniparser_getint(g_pIni, "VCASetConfig:display_target", 0);
            int iIniDisplayTrace = iniparser_getint(g_pIni, "VCASetConfig:display_trace", 0);
            int iIniTraceLen = iniparser_getint(g_pIni, "VCASetConfig:trace_len", 0);
            int iIniTargetColor = iniparser_getint(g_pIni, "VCASetConfig:target_color", 0);
            int iIniAlarmColor = iniparser_getint(g_pIni, "VCASetConfig:alarm_color", 0);

            vca_TConfig& config = vcaParam.chnParam[g_iIniChannel].config;
            config.iDisplayTarget = iIniDisplayTarget;
            config.iDisplayTrace = iIniDisplayTrace;
            config.iTraceLength = iIniTraceLen;
            config.iTargetColor = iIniTargetColor;
            config.iTargetAlarmColor = iIniAlarmColor;
            NetClient_VCASetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_SET_TARGET_PARAM, &vcaParam, sizeof(vca_TVCAParam));
            fprintf(stderr, "NetClient_VCASetConfig Wait .................. \n");
            usleep(2000*1000);

            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            NetClient_VCAGetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_GET_TARGET_PARAM, &vcaParam, sizeof(vca_TVCAParam));
            int iDisplayTarget = config.iDisplayTarget;
            int iDisplayTrace = config.iDisplayTrace;
            int iTraceLen = config.iTraceLength;
            int iTargetColor = config.iTargetColor;
            int iAlarmColor = config.iTargetAlarmColor;

            if(iDisplayTarget == iIniDisplayTarget &&
               iDisplayTrace == iIniDisplayTrace &&
               iTraceLen == iIniTraceLen &&
               iTargetColor == iIniTargetColor && 
               iAlarmColor == iIniAlarmColor)
            {
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->target param.................. [OK]\n");
            }
            else
            {
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->target param.................. [FAILED]\n");
            }
           
            break; 
        }
    case 4:     //rule common
        {
            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            int iIniRuleID = iniparser_getint(g_pIni, "VCASetConfig:rule_id", 0);
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            vca_TRuleParam& rulePara = vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID];
            char cIniRuleName[32] = {0};
            strcpy(cIniRuleName, iniparser_getstring(g_pIni, "VCASetConfig:rulename", NULL));
            strcpy(rulePara.cRuleName, cIniRuleName);
            int iIniRuleValid = iniparser_getint(g_pIni, "VCASetConfig:rule_valid", 0);
            rulePara.iValid = iIniRuleValid;
            NetClient_VCASetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_SET_RULE_COMMON, &vcaParam, sizeof(vca_TVCAParam));
            fprintf(stderr, "NetClient_VCASetConfig Wait .................. \n");
            usleep(2000*1000);

            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            NetClient_VCAGetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_GET_RULE_COMMON, &vcaParam, sizeof(vca_TVCAParam));
            char cRuleName[32] = {0};
            strcpy(cRuleName, rulePara.cRuleName);
            int iRuleValid = rulePara.iValid;    
            if(!strcmp(cRuleName, cIniRuleName) &&
               iRuleValid == iIniRuleValid)
            {
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->Rule Common Para.................. [OK]\n");
            }
            else
            {
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->Rule Common Para.................. [FAILED]\n");
            }

            break;
        }
    case 5:  //tripwire
        {
            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            int iIniRuleID = iniparser_getint(g_pIni, "VCASetConfig:rule_id", 0);
            //int iEventID = iniparser_getint(g_pIni, "VCASetConfig:event_id", 0);
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            //vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = iEventID;
            vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = VCA_EVENT_TRIPWIRE;

            int iIniRuleValid = iniparser_getint(g_pIni, "VCASetConfig:comm_rule_valid", 0);
            int iIniDisply = iniparser_getint(g_pIni, "VCASetConfig:rule_display", 0);
            int iIniAlarmSta = iniparser_getint(g_pIni, "VCASetConfig:alarm_sta_enable", 0);
            int iIniAlarmColor = iniparser_getint(g_pIni, "VCASetConfig:alarm_color", 0);
            int iIniNoAlarmColor = iniparser_getint(g_pIni, "VCASetConfig:noalarm_color", 0);
            int iIniMinTime = iniparser_getint(g_pIni, "VCASetConfig:mintime", 0);
            int iIniMinDistance = iniparser_getint(g_pIni, "VCASetConfig:mindistance", 0);
            int iIniDirection = iniparser_getint(g_pIni, "VCASetConfig:direction", 0);
            int iIniTypeCheck = iniparser_getint(g_pIni, "VCASetConfig:typecheck", 0);
			//ܽ粻ͬ
			int iIniTwo_way = iniparser_getint(g_pIni, "VCASetConfig:is_twoway", 0);
            int iIniLineX = iniparser_getint(g_pIni, "VCASetConfig:lineX", 0);
            int iIniLineY = iniparser_getint(g_pIni, "VCASetConfig:lineY", 0);
            int iIniLineX1 = iniparser_getint(g_pIni, "VCASetConfig:lineX1", 0);
            int iIniLineY1 = iniparser_getint(g_pIni, "VCASetConfig:lineY1", 0);

            vca_TRuleParam& rp = vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID];
            vca_TTripwire& tw = vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].events.tripwire;
            tw.iValid = iIniRuleValid;
            rp.stDisplayParam.iDisplayRule = iIniDisply;
            rp.stDisplayParam.iDisplayStat = iIniAlarmSta;
            rp.stDisplayParam.iAlarmColor = iIniAlarmColor;
            rp.stDisplayParam.iColor = iIniNoAlarmColor;
            tw.iMinTime = iIniMinTime;
            tw.iMinDistance = iIniMinDistance;
            tw.iDirection = iIniDirection;
            tw.iTargetTypeCheck = iIniTypeCheck;
            tw.iType = iIniTwo_way;    //ͣ˫
            tw.stLine.stStart.iX = iIniLineX;
            tw.stLine.stStart.iY = iIniLineY;
            tw.stLine.stEnd.iX = iIniLineX1;
            tw.stLine.stEnd.iY = iIniLineY1;

            NetClient_VCASetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_SET_RULE0_TRIPWIRE, &vcaParam, sizeof(vca_TVCAParam));
            fprintf(stderr, "NetClient_VCASetConfig Wait .................. \n");
			NetClient_VCARestart(g_iLogonID);
            usleep(3000*1000);

            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = VCA_EVENT_TRIPWIRE;
            NetClient_VCAGetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_GET_RULE0_TRIPWIRE, &vcaParam, sizeof(vca_TVCAParam));
            int iRuleValid = tw.iValid;
            int iDisply = rp.stDisplayParam.iDisplayRule;
            int iAlarmSta = rp.stDisplayParam.iDisplayStat;
            int iAlarmColor = rp.stDisplayParam.iAlarmColor;
            int iNoAlarmColor = rp.stDisplayParam.iColor;
            int iMinTime = tw.iMinTime;
            int iMinDistance = tw.iMinDistance;
            int iDirection = tw.iDirection;
            int iTypeCheck = tw.iTargetTypeCheck;
            int iType = tw.iType;
            int iLineX = tw.stLine.stStart.iX;
            int iLineY = tw.stLine.stStart.iY;
            int iLineX1 = tw.stLine.stEnd.iX;
            int iLineY1 = tw.stLine.stEnd.iY;

            if(iRuleValid == iIniRuleValid &&
               iDisply == iIniDisply &&
               iAlarmSta == iIniAlarmSta &&
               iAlarmColor == iIniAlarmColor &&
               iNoAlarmColor == iIniNoAlarmColor &&
               iMinTime == iIniMinTime &&
               iMinDistance == iIniMinDistance &&
               iDirection == iIniDirection &&
               iTypeCheck == iIniTypeCheck &&
               iType == iIniTwo_way &&
               iLineX == iIniLineX &&
               iLineY == iIniLineY &&
               iLineX1 == iIniLineX1 &&
               iLineY1 == iIniLineY1)
            {
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->set tripwire.................. [OK]\n");
            }
            else
            {
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->set tripwire.................. [FAILED]\n");
            }          
            break;      
        }
    case 6:     //perimeter
        {
            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            int iIniRuleID = iniparser_getint(g_pIni, "VCASetConfig:rule_id", 0);
            //int iEventID = iniparser_getint(g_pIni, "VCASetConfig:event_id", 0);
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            //vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = iEventID;
            vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = VCA_EVENT_PERIMETER;
            
            int iIniRuleValid = iniparser_getint(g_pIni, "VCASetConfig:rule_valid", 0);
            int iIniDisply = iniparser_getint(g_pIni, "VCASetConfig:rule_display", 0);
            int iIniAlarmSta = iniparser_getint(g_pIni, "VCASetConfig:alarm_sta_enable", 0);
            int iIniAlarmColor = iniparser_getint(g_pIni, "VCASetConfig:alarm_color", 0);
            int iIniNoAlarmColor = iniparser_getint(g_pIni, "VCASetConfig:noalarm_color", 0);
            int iIniMinTime = iniparser_getint(g_pIni, "VCASetConfig:mintime", 0);
            int iIniMinDistance = iniparser_getint(g_pIni, "VCASetConfig:mindistance", 0);
            int iIniDirection = iniparser_getint(g_pIni, "VCASetConfig:direction", 0);
            int iIniTypeCheck = iniparser_getint(g_pIni, "VCASetConfig:typecheck", 0);
            int iIniDirLimit = iniparser_getint(g_pIni, "VCASetConfig:dir_limit", 0);
            int iIniDetectMode = iniparser_getint(g_pIni, "VCASetConfig:detect_mode", 0);
            int iIniPointNum = iniparser_getint(g_pIni, "VCASetConfig:point_num", 0);
            POINT ptArr[32] = {{0}};
            char cFilter[64] = {0};
            for(int i=0; i<iIniPointNum; i++)
            {
                sprintf(cFilter, "VCASetConfig:p%d", i);
                char* pt1 = iniparser_getstring(g_pIni, cFilter, NULL);
                sscanf(pt1, "%d,%d", &ptArr[i].x, &ptArr[i].y);
            }
            vca_TRuleParam& rp = vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID];
            vca_TPerimeter& pm = vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].events.perimeter;
            pm.iValid = iIniRuleValid;
            rp.stDisplayParam.iDisplayRule = iIniDisply;
            rp.stDisplayParam.iDisplayStat = iIniAlarmSta;
            rp.stDisplayParam.iAlarmColor = iIniAlarmColor;
            rp.stDisplayParam.iColor = iIniNoAlarmColor;
            pm.iMinTime = iIniMinTime;
            pm.iMinDistance = iIniMinDistance;
            pm.iDirection = iIniDirection;
            pm.iTargetTypeCheck = iIniTypeCheck;
            pm.iType = iIniDirLimit;
            pm.iMode = iIniDetectMode;
            pm.stRegion.iPointNum = iIniPointNum;
            for(int i=0; i<iIniPointNum; i++)
            {
                    pm.stRegion.stPoints[i].iX = ptArr[i].x;
                    pm.stRegion.stPoints[i].iY = ptArr[i].y;
            }
            NetClient_VCASetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_SET_RULE2_PERIMETER, &vcaParam, sizeof(vca_TVCAParam));
            fprintf(stderr, "NetClient_VCASetConfig Wait .................. \n");
			NetClient_VCARestart(g_iLogonID);
            usleep(3000*1000);

            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = VCA_EVENT_PERIMETER;
            NetClient_VCAGetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_GET_RULE2_PERIMETER, &vcaParam, sizeof(vca_TVCAParam));
            int iRuleValid = pm.iValid;
            int iDisply = rp.stDisplayParam.iDisplayRule;
            int iAlarmSta = rp.stDisplayParam.iDisplayStat;
            int iAlarmColor = rp.stDisplayParam.iAlarmColor;
            int iNoAlarmColor = rp.stDisplayParam.iColor;
            int iMinTime = pm.iMinTime;
            int iMinDistance = pm.iMinDistance;
            int iDirection = pm.iDirection;
            int iTypeCheck = pm.iTargetTypeCheck;
            int iType = pm.iType;
            int iDetectMode = pm.iMode;
            int iPointNum = pm.stRegion.iPointNum;
            POINT ptArrTemp[32] = {{0}};
            for(int i=0; i<iPointNum; i++)
            {    
                ptArrTemp[i].x = pm.stRegion.stPoints[i].iX;
                ptArrTemp[i].y = pm.stRegion.stPoints[i].iY;
            }

            bool bOK = false;
            if(iRuleValid == iIniRuleValid &&
               iDisply == iIniDisply &&
               iAlarmSta == iIniAlarmSta &&
               iAlarmColor == iIniAlarmColor &&
               iNoAlarmColor == iIniNoAlarmColor &&
               iMinTime == iIniMinTime &&
               iMinDistance == iIniMinDistance &&
               iDirection == iIniDirection &&
               iTypeCheck == iIniTypeCheck &&
               iType == iIniDirLimit && 
               iDetectMode == iIniDetectMode && 
               iPointNum == iIniPointNum)
            {
                    bOK = true;
                    for(int i=0; i<iPointNum; i++)
                    {
                            if(ptArr[i].x == ptArrTemp[i].x &&
                               ptArr[i].y == ptArrTemp[i].y)
                            {
                                    continue;
                            }
                            bOK = false;
                            break;
                    }
            }

            if(bOK)
                    fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->set perimeter.................. [OK]\n");
            else
                    fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->set perimeter.................. [FAILED]\n");
            
            break;
        }
    case 7:		//alarm schedule
        {
            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            int iIniRuleID = iniparser_getint(g_pIni, "VCASetConfig:rule_id", 0);
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = VCA_EVENT_TRIPWIRE;
            int iIniWeekDay = iniparser_getint(g_pIni, "VCASetConfig:weekday", 0);			
            char cFilter[64] = {0};
            int iIniTimeTemp[4][5] = {{0}};
            vca_TAlarmSchedule& as = vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].alarmSchedule;
            for(int i=0; i<4; i++)
            {
                sprintf(cFilter, "VCASetConfig:timeseg%d", i);
                char* strTimeSeg = iniparser_getstring(g_pIni, cFilter, NULL);
                sscanf(strTimeSeg, "%d:%d~%d:%d,%d",
                            &iIniTimeTemp[i][0], &iIniTimeTemp[i][1], &iIniTimeTemp[i][2], &iIniTimeTemp[i][3], &iIniTimeTemp[i][4]);
                as.timeSeg[iIniWeekDay][i].iStartHour = iIniTimeTemp[i][0];
                as.timeSeg[iIniWeekDay][i].iStartMinute = iIniTimeTemp[i][1];
                as.timeSeg[iIniWeekDay][i].iStopHour = iIniTimeTemp[i][2];
                as.timeSeg[iIniWeekDay][i].iStopMinute = iIniTimeTemp[i][3];
                as.timeSeg[iIniWeekDay][i].iEnable = iIniTimeTemp[i][4];
            }
            
            NetClient_VCASetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_SET_ALARM_SCHEDULE, 
                                                       &vcaParam, sizeof(vca_TVCAParam));
            fprintf(stderr, "NetClient_VCASetConfig Wait .................. \n");
            usleep(1000*1000);
        
            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = VCA_EVENT_TRIPWIRE;
            NetClient_VCAGetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_GET_ALARM_SCHEDULE, 
                                                       &vcaParam, sizeof(vca_TVCAParam));
            int iWeekday = as.iWeekday;
            bool bOK = false;
            if(iWeekday == iIniWeekDay)
            {
                bOK = true;
                for(int i=0; i<4; i++)
                {
                    if(as.timeSeg[iWeekday][i].iStartHour == iIniTimeTemp[i][0] &&
                       as.timeSeg[iWeekday][i].iStartMinute == iIniTimeTemp[i][1] &&
                       as.timeSeg[iWeekday][i].iStopHour == iIniTimeTemp[i][2] &&
                       as.timeSeg[iWeekday][i].iStopMinute == iIniTimeTemp[i][3] &&
                       as.timeSeg[iWeekday][i].iEnable == iIniTimeTemp[i][4])
                    {
                        continue;
                    }
                    bOK = false;
                    break;
               }
            }
            if(bOK)
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->set VCA alarm schedule.................. [OK]\n");
            else
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->set VCA alarm schedule.................. [FAILED]\n");
            
            break;
        }
    case 8:		//alarm link
        {
            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            int iIniRuleID = iniparser_getint(g_pIni, "VCASetConfig:rule_id", 0);
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = VCA_EVENT_TRIPWIRE;
            int iIniLinkType = iniparser_getint(g_pIni, "VCASetConfig:linktype", 0);
            vca_TAlarmLink& al = vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].alarmLink;
            int iIniChanBits = iniparser_getint(g_pIni, "VCASetConfig:channelbits", 0);
            int iIniLinkChannel = iniparser_getint(g_pIni, "VCASetConfig:linkchannel", 0);
            int iIniLinkPTZType = iniparser_getint(g_pIni, "VCASetConfig:linkPTZType", 0);
            int iIniLinkNo = iniparser_getint(g_pIni, "VCASetConfig:link_no", 0);
            if(iIniLinkType == VCA_ARARMLINK_SCREEMSHOW || iIniLinkType == VCA_ALARMLINK_AUDIO || 
               iIniLinkType == VCA_ALARMLINK_OUTPORT || iIniLinkType == VCA_ALARMLINK_RECODER ||
               iIniLinkType == VCA_ALARMLINK_CAPTUREPIC
               )                                     
            {
                al.iLinkSet[iIniLinkType] = iIniChanBits;
            }
            else if(iIniLinkType == 4)
            {
                al.iLinkChannel = iIniLinkChannel;
                switch (iIniLinkPTZType)
                {
                case 0:al.ptz[iIniLinkChannel].usPresetNO = iIniLinkNo; break;
                case 1:al.ptz[iIniLinkChannel].usTrackNO = iIniLinkNo; break;
                case 2:al.ptz[iIniLinkChannel].usPathNO = iIniLinkNo; break; 
                default:break;
                }
            }
            
            NetClient_VCASetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_SET_ALARM_LINK, 
                                                       &vcaParam, sizeof(vca_TVCAParam));
            fprintf(stderr, "NetClient_VCASetConfig Wait .................. \n");
            usleep(1000*1000);

            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = VCA_EVENT_TRIPWIRE;
            NetClient_VCAGetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_GET_ALARM_LINK, 
                                                       &vcaParam, sizeof(vca_TVCAParam));

            bool bOK = false;
            if(iIniLinkType == 2)
            {
                if(al.iLinkSet[iIniLinkType] == iIniChanBits)
                    bOK = true;
            }
            else if(iIniLinkType == 4)
            {
                switch (iIniLinkPTZType)
                {
                case 0:
                    {
                        if(al.ptz[iIniLinkChannel].usPresetNO == iIniLinkNo)
                            bOK = true;
                        break;
                    }
                case 1:
                    {
                        if(al.ptz[iIniLinkChannel].usTrackNO == iIniLinkNo)
                            bOK = true;
                        break;
                    }
                case 2:
                    {
                        if(al.ptz[iIniLinkChannel].usPathNO == iIniLinkNo)
                            bOK = true;
                        break;
                    }
                default: break;
                }
            }

            if(bOK)
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->set VCA alarm link.................. [OK]\n");
            else
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->set VCA alarm link.................. [FAILED]\n");
            
            break;
        }
    case 9: 	//alarm schedule enable
        {
            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            int iIniRuleID = iniparser_getint(g_pIni, "VCASetConfig:rule_id", 0);
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = VCA_EVENT_TRIPWIRE;
    
            int iIniSchEnable = iniparser_getint(g_pIni, "VCASetConfig:alarm_sch_enable", 0);
            int iIniSchParam = iniparser_getint(g_pIni, "VCASetConfig:alarm_sch_param", 0); 
            vca_TScheduleEnable& te = vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].scheduleEnable;
            te.iEnable = iIniSchEnable;
            te.iParam = iIniSchParam;
            NetClient_VCASetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_SET_SCHEDULE_ENABLE, 
                                                       &vcaParam, sizeof(vca_TVCAParam));
            fprintf(stderr, "NetClient_VCASetConfig Wait .................. \n");
            usleep(1000*1000);

            memset(&vcaParam, 0, sizeof(vca_TVCAParam));
            vcaParam.iChannelID = g_iIniChannel;
            vcaParam.chnParam[g_iIniChannel].iRuleID = iIniRuleID;
            vcaParam.chnParam[g_iIniChannel].rule[iIniRuleID].iEventID = VCA_EVENT_TRIPWIRE;
            NetClient_VCAGetConfig(g_iLogonID, g_iIniChannel, VCA_CMD_GET_SCHEDULE_ENABLE, 
                                                       &vcaParam, sizeof(vca_TVCAParam));

            if(te.iEnable == iIniSchEnable &&
               te.iParam == iIniSchParam)
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->set VCA alarm scheduleEnable.................. [OK]\n");
            else
                fprintf(stderr, "NetClient_VCASetConfig NetClient_VCAGetConfig--->set VCA alarm scheduleEnable.................. [FAILED]\n");

            break;
        }
    }
}

void Auto_SetGetColorToGray()
{
    // SetColorToGray
    int iIniEnable = iniparser_getint(g_pIni, "SetColorToGray:enable", -1);

    NetClient_SetColorToGray(g_iLogonID, g_iIniChannel, iIniEnable);

    fprintf(stderr, "SetColorToGray Wait .................. \n");
    usleep(1000*1000);

    // GetColorToGray
    int iEnable = 0;

    NetClient_GetColorToGray(g_iLogonID, g_iIniChannel, &iEnable);
    if(iEnable == iIniEnable)
    {
        fprintf(stderr, "SetColorToGray GetColorToGray .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetColorToGray GetColorToGray .................. [FAIL]\n");
    }
}

void Auto_GetExceptionMsg()
{
    int iExceptionType = iniparser_getint(g_pIni, "GetExceptionMsg:iExceptionType", -1);
    int iState = 0;
    int iRet =  NetClient_GetExceptionMsg(g_iLogonID, iExceptionType, &iState);
    fprintf(stderr, "GetExceptionMsg Wait .................. \n");
    usleep(1000*1000);
    if(iRet != 0)
    {
         fprintf(stderr, "GetExceptionMsg .................. [FAIL]\n");
    }
    else
    {
         fprintf(stderr, "GetExceptionMsg .................. [OK]\n");
    }
}
void Auto_SetGetCHNPTZFormat()
{
    //SetCHNPTZFormat
    char *cComFormat = iniparser_getstring(g_pIni, "SetCHNPTZFormat:ComFormat", NULL);
    NetClient_SetCHNPTZFormat(g_iLogonID, g_iIniChannel, cComFormat);

    fprintf(stderr, "SetCHNPTZFormat Wait .................. \n");
    usleep(1000*1000);
    //GetCHNPTZFormat
    char cFormat[256] = {0};    
    NetClient_GetCHNPTZFormat(g_iLogonID, g_iIniChannel, cFormat);
    if(0 == strcmp(cFormat, cComFormat))
    {
        fprintf(stderr, "SetCHNPTZFormat GetCHNPTZFormat .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetCHNPTZFormat GetCHNPTZFormat .................. [FAIL]\n");
    }

}
void Auto_GetProtocolList()
{
    //GetProtocolList
    st_NVSProtocol nvsProtocol = {0};
    int iRet = NetClient_GetProtocolList(g_iLogonID, &nvsProtocol);
    if(iRet != 0)
    {
         fprintf(stderr, "GetProtocolList .................. [FAIL]\n");
    }
    else
    {
         fprintf(stderr, "GetProtocolList .................. [OK]\n");
    }
}
void Auto_SetGetCHNPTZCRUISE()
{
    //SetCHNPTZCRUISE
    int iCruiseNo = iniparser_getint(g_pIni, "SetCHNPTZCRUISE:iCruiseNo", -1);
    int iIniEnable = iniparser_getint(g_pIni, "SetCHNPTZCRUISE:enable", -1);
    int iIniCuriseNum = iniparser_getint(g_pIni, "SetCHNPTZCRUISE:iCuriseNum", -1);
    st_PTZCruise stPTZCruise;
    memset(&stPTZCruise, 0, sizeof(stPTZCruise));
    char *pcPreset0 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cPreset0", NULL);
    char *pcPreset1 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cPreset1", NULL);
    char *pcPreset2 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cPreset2", NULL);
    char *pcPreset3 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cPreset3", NULL);
    char *pcStayTime0 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cStayTime0", NULL);
    char *pcStayTime1 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cStayTime1", NULL);
    char *pcStayTime2 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cStayTime2", NULL);
    char *pcStayTime3 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cStayTime3", NULL);
    char *pcSpeed0 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cSpeed0", NULL);
    char *pcSpeed1 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cSpeed1", NULL);
    char *pcSpeed2 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cSpeed2", NULL);
    char *pcSpeed3 = iniparser_getstring(g_pIni, "SetCHNPTZCRUISE:cSpeed3", NULL);
    stPTZCruise.iPreset[0] = to_int_def(pcPreset0);
    stPTZCruise.iPreset[1] = to_int_def(pcPreset1);
    stPTZCruise.iPreset[2] = to_int_def(pcPreset2);
    stPTZCruise.iPreset[3] = to_int_def(pcPreset3);
    stPTZCruise.iStayTime[0] = to_int_def(pcStayTime0);	
    stPTZCruise.iStayTime[1] = to_int_def(pcStayTime1);
    stPTZCruise.iStayTime[2] = to_int_def(pcStayTime2);
    stPTZCruise.iStayTime[3] = to_int_def(pcStayTime3);
    stPTZCruise.iPreset[0] = to_int_def(pcSpeed0);
    stPTZCruise.iPreset[1] = to_int_def(pcSpeed1);
    stPTZCruise.iPreset[2] = to_int_def(pcSpeed2);
    stPTZCruise.iPreset[3] = to_int_def(pcSpeed3);

    NetClient_SetCHNPTZCRUISE(g_iLogonID, g_iIniChannel, iCruiseNo, iIniEnable, iIniCuriseNum, &stPTZCruise);
    fprintf(stderr, "SetCHNPTZCRUISE Wait .................. \n");
    usleep(1000*1000);
    //GetCHNPTZCRUISE
    int iCruiseNoGet = iniparser_getint(g_pIni, "SetCHNPTZCRUISE:iCruiseNo", -1);
    int iEnable = 0;
    int iCruiseNum = 0;
    st_PTZCruise stPTZCruiseGet;
	memset(&stPTZCruiseGet, 0, sizeof(stPTZCruiseGet));
    NetClient_GetCHNPTZCRUISE(g_iLogonID, g_iIniChannel, iCruiseNoGet, &iEnable, &iCruiseNum, &stPTZCruiseGet);
    for(int i = 0; i < 4; i++)
    {
        if(iEnable == iIniEnable && iCruiseNum == iIniCuriseNum && stPTZCruiseGet.iPreset[i] == stPTZCruise.iPreset[i]
            && stPTZCruise.iStayTime[i] == stPTZCruise.iStayTime[i] && stPTZCruiseGet.iSpeed[i] == stPTZCruise.iSpeed[i])
        {
            fprintf(stderr, "SetCHNPTZCRUISE GetCHNPTZCRUISE .................. [OK]\n");
        }
        else
        {
            fprintf(stderr, "SetCHNPTZCRUISE GetCHNPTZCRUISE.................. [FAIL]\n");
        }
    }
}

void Auto_SetGetFTPUpdate()
{
    //SetFTPUpdate
    char *pcFtpAddress = iniparser_getstring(g_pIni, "SetFTPUpdate:cFtpAddress", NULL);
    char *pcFilePath = iniparser_getstring(g_pIni, "SetFTPUpdate:cFilePath", NULL);
    char *pcUserName = iniparser_getstring(g_pIni, "SetFTPUpdate:cUserName", NULL);
    char *pcPassWord = iniparser_getstring(g_pIni, "SetFTPUpdate:cPassWord", NULL);
    NetClient_SetFTPUpdate(g_iLogonID, pcFtpAddress, pcFilePath, pcUserName, pcPassWord);
    fprintf(stderr, "SetFTPUpdate Wait .................. \n");
    usleep(1000*1000);
    //GetFTPUpdate
    char cFtpAddress[256] = {0};
    char cFilePath[256] = {0};
    char cUserName[256] = {0};
    char cPassWord[256] = {0};
    NetClient_GetFTPUpdate(g_iLogonID, cFtpAddress, cFilePath, cUserName, cPassWord);
    if(cFtpAddress == pcFtpAddress && cFilePath == pcFilePath && cUserName == pcUserName && cPassWord == pcPassWord)
    {
        fprintf(stderr, "SetFTPUpdate GetFTPUpdate .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetFTPUpdate GetFTPUpdate .................. [FAIL]\n");
    }

}

void Auto_SetGetOSDTypeColor()
{
    //SetOSDTypeColor
    int iOSDType = iniparser_getint(g_pIni, "SetOSDTypeColor:iOSDType", -1);
    int iColor = iniparser_getint(g_pIni, "SetOSDTypeColor:iColor", -1);

    NetClient_SetOSDTypeColor(g_iLogonID, g_iIniChannel, iOSDType, iColor);
    fprintf(stderr, "SetOSDTypeColor Wait .................. \n");
    usleep(1000*1000);
    //GetOSDTypeColor
    int iGetColor = 0;
    NetClient_GetOSDTypeColor(g_iLogonID, g_iIniChannel, iOSDType, &iGetColor);
    if(iGetColor == iColor)
    {
        fprintf(stderr, "SetOSDTypeColor GetOSDTypeColor .................. [OK]\n");
    }
    else
    {
        fprintf(stderr, "SetFTPUpdate GetFTPUpdate .................. [FAIL]\n");
    }
}

void Auto_NetFileSetGetChannelParam()
{
	//NetFileSetChannelParam
	int iCmd = iniparser_getint(g_pIni, "NetFileSetChannelParam:iOSDType", -1);
	int iType = iniparser_getint(g_pIni, "NetFileSetChannelParam:iColor", -1);
	int iValue = iniparser_getint(g_pIni, "NetFileSetChannelParam:iColor", -1);
	STORAGE_RULE stStorageRuleSet = {0};
	stStorageRuleSet.iSize = sizeof(stStorageRuleSet);
	stStorageRuleSet.iType = iType;
	stStorageRuleSet.iValue = iValue;

	if(0!=NetClient_NetFileSetChannelParam(g_iLogonID, g_iIniChannel, iCmd, (void*)&stStorageRuleSet))
	{
		fprintf(stderr, "NetClient_NetFileSetChannelParam .................. [FAIL]\n");
		return;
	}
	fprintf(stderr, "NetFileSetChannelParam Wait .................. \n");
	usleep(1000*1000);
	//NetFileGetChannelParam
	STORAGE_RULE stStorageRuleGet = {0};
	stStorageRuleGet.iSize = sizeof(stStorageRuleGet);

	if(0!=NetClient_NetFileGetChannelParam(g_iLogonID, g_iIniChannel, iCmd, (void*)&stStorageRuleGet))
	{
		fprintf(stderr, "NetClient_NetFileGetChannelParam .................. [FAIL]\n");
		return;
	}

	if(memcmp(&stStorageRuleGet, &stStorageRuleSet, sizeof(stStorageRuleSet))!=0)
	{
		fprintf(stderr, "NetFileSetChannelParam NetFileGetChannelParam .................. [OK]\n");
	}
	else
	{
		fprintf(stderr, "NetFileSetChannelParam NetFileGetChannelParam .................. [FAIL]\n");
	}
}

